var featherEditor;
var featherEditorType;

var ajaxSchoolSearch;

var imageHolder;
var showMessage = false;
var player;
var editor;

var follow_id = 0;
var follow_follow = 0;

var photo_page = 2;
var video_page = 2;

var sync_time = 10000;
var sync_time_default = 10000;
var sync_time_incr = 10000;
var sync_time_max = 60000;

var dialog;
var feed_page = 1;
var announcements_page = 1;
var last_announcement_id = 0;
	
var $curr_video_o;


$(document).ready(function() {
	//$('#dialog').dialog({ modal: true, width: 600, autoOpen: false });	
	defaultProfileAssets();
	initAssets();
	preInitComments();
});

function preInitComments() {
	$('.comments-block').each(function() {
		var $obj = $(this);
		var id = $(this).attr('id').replace('comments_block_', '');
		var media = $(this).hasClass('media_comment')?1:0;
		var ref = $(this).hasClass('ref_comment')?1:0;
		if (!$(this).hasClass('loaded-comment-block')) {
			$.post('profile/ajax/comments.cfm', {id:(id.replace('_alt', '')), media:media, ref:ref, last_date_viewed: (('#last_date_viewed').length)?$('#last_date_viewed').val():''}, function(data) {
				$obj.find('.comments').html(data);
				if ($obj.find('.comment-btn').length) {
					if ($obj.find('.rowComment-activity .row-content-holder').length) {
					}
					else {
						$obj.find('.comment-btn').show();
						$obj.find('.comment-new').hide();
					}
				}
				if ($obj.find('.user-frame-feed').length== 0 && $obj.find('.comment-form').length == 0) {
					$obj.remove();
				}
				$obj.addClass('loaded-comment-block');
				initComments();	
			});
		}
	});	
}

var submittingComment = false;
function submitComment($o) {
	var $obj = $o.closest('.comments-block');
	var id = $obj.attr('id').replace('comments_block_', '');
	var media = $obj.hasClass('media_comment')?1:0;
	var comment = $obj.find('#comment_post_' + id).val();
	var show_all = (($obj.find('.all-comments a').hasClass('view_recent_comments'))?1:0);
	var media_id = $obj.find('.comment_media_id').val();
	var media_type = $obj.find('.comment_media_type').val();
	var ref = $obj.hasClass('ref_comment')?1:0;
	var media_ids = '';
	$obj.find('.announcement_attachments .announcement_attachment_media').each(function() {
		media_ids = ListAppend(media_ids, $(this).attr('id').replace('member_media_', ''));
	});
	if (comment.length > 0 && !submittingComment) {
		submittingComment = true;
		showStatus('status_comment_' + id, 'Posting comment ...');
		$obj.find('.btn_comment_post').hide();
		$.post('profile/ajax/comments.cfm', {id:(id.replace('_alt', '')), media:media, comment:comment, show_all:show_all, ref:ref, media_id:media_id, media_ids:media_ids, media_type:media_type}, function(data) {
			if (data.substring(0, 6) == 'ERROR:') {
				showAlert(data.substring(6, data.length));
			}
			else {
				$obj.find('.comments').html(data);
			}
			$obj.find('#comment_post_' + id).val('');
			$obj.find('.comment_media_type').val('1');
			$obj.find('.comment_media_id').val('');
			$obj.find('.comment_media_preview').html('');
			$obj.find('.comment_attachment').hide();
			$obj.find('.comment_attach').show();
			$obj.find('.announcement_attachments').html('');
			$obj.find('.comment-form .comment_attachment').hide();
			$obj.find('.announcement_attachments_block').hide();
			$obj.find('.btn_comment_post').show();
			hideStatus('status_comment_' + id);
			initComments();
			submittingComment = false;
		});
	}
	else {
		showStatus('status_comment_' + id, 'Please enter your comment', 'error');	
		$obj.find('.btn_comment_post').show();	
	}
	return false;
}

function submitEditedComment($o) {
	var $obj = $o.closest('.rowComment-activity');
	var id = $o.attr('id').replace('comment_edit_', '');
	var comment = $o.val();
	if (comment.length > 0) {
		showStatus('status_comment_edit_' + id, 'Updating comment ...');		
		$.post('profile/ajax/comment_edit.cfm', {id:id, comment:comment}, function(data) {
			$obj.find('.comment_view').html(comment);
			$obj.find('.comment_edit_txt').hide();
			$obj.find('.comment_edit_txt').val('');
			$obj.find('.comment_view').show();
			hideStatus('status_comment_edit_' + id);
			initComments();	
		});
	}
	else {
		showStatus('status_comment_edit_' + id, 'Please enter your updated comment', 'error');		
	}
	return false;
}

function submitReplyComment($o) {
	var $obj = $o.closest('.rowComment-activity');
	var $obj2 = $o.closest('.comments-block');
	var id = $o.attr('id').replace('comment_reply_', '');
	var comment = $o.val();
	if (comment.length > 0) {
		showStatus('status_comment_reply_' + id, 'Adding reply ...');		
		$.post('profile/ajax/comment_reply.cfm', {id:id, comment:comment}, function(data) {
			//$obj.find('.comment_view').html(comment);
			$obj2.find('.comments').html(data);
			$obj.find('.comment_reply_txt').hide();
			$obj.find('.comment_reply_txt').val('');
			$obj.find('.comment_reply').show();
			hideStatus('status_comment_reply_' + id);
			initComments();	
		});
	}
	else {
		showStatus('status_comment_reply_' + id, 'Please enter your updated comment', 'error');		
	}
	return false;
}

updatePopupShown = false;
function initComments() {
	
	if ($('#profile_answers .new-bg').length) {
		$('.show-profile-answers').prev().addClass('new-bg');
	}
	if ($('.new-bg').length && $('.new_profile_msg').length == 0 && $('#member_first_name').length && !updatePopupShown) {
		updatePopupShown = true;
		$('#new_profile_alert').show();
		//openProfileDialog('Profile updated since your last visit', 'profile_new_msg.cfm?n=' + encodeURI($('#member_first_name').val()), 400);
	}
	
	//$('.btn_comment').off('click').on('click', function() {
	/*
	$('.comment_post').each(function() {
		var $obj = $(this);
		if ($obj.hasClass('comment_post')) {
			$obj.removeClass('comment_post');
			$obj.on('keydown', function (event) {
				var keycode = (event.keyCode ? event.keyCode : event.which);
				if (keycode == '13' && !event.shiftKey) {
					event.preventDefault();
					submitComment($obj);
				}
			});
		}
	});
	*/
	
	$('.comment-btn a').off('click').on('click', function() {
		var $obj = $(this).closest('.comments-block');
		$obj.find('.comment-btn').hide();
		$obj.find('.comment-new').show();
	});
	
	$('.btn_comment_post').off('click').on('click', function() {
		submitComment($(this));
	});
	$('.comment_post_edit').each(function() {
		if ($(this).hasClass('comment_post_edit')) {
			$(this).removeClass('comment_post_edit');
			$(this).on('keydown', function (event) {		
				var keycode = (event.keyCode ? event.keyCode : event.which);
				if(keycode == '13') {
					event.preventDefault();
					submitEditedComment($(this));
				}
			});
		}
	});
	$('.comment_post_reply').each(function(e) {
		if ($(this).hasClass('comment_post_reply')) {
			//e.preventDefault();
			$(this).removeClass('comment_post_reply');
			$(this).on('keydown', function (event) {		
				var keycode = (event.keyCode ? event.keyCode : event.which);
				if(keycode == '13') {
					event.preventDefault();
					submitReplyComment($(this));
				}
			});
		}
	});
	
	$('.btn-reply-comment').off('click').on('click', function(e) {
		//e.preventDefault();
		var id = $(this).attr('id').replace('btn_reply_comment_', '');
		$('#reply_comment_txt_' + id).show();
		$(this).remove();
	});
	
	$('.btn_comment_post_edit').off('click').on('click', function() {
		$obj = $('#comment_edit_' + $(this).attr('id').replace('btn_comment_edit_', ''));
		submitEditedComment($obj);
	});
	$('.btn_comment_post_reply').off('click').on('click', function() {
		$obj = $('#comment_reply_' + $(this).attr('id').replace('btn_comment_reply_', ''));
		submitReplyComment($obj);
	});
	
	$('.view_all_comments').off('click').on('click', function() {
		showComments($(this), 1);
	});
	
	$('.view_recent_comments').off('click').on('click', function() {
		showComments($(this), 0);
	});
	
	$('.comment_del').off('click').on('click', function() {	
		var $obj = $(this).closest('.comments-block');
		var id = $obj.attr('id').replace('comments_block_', '');
		var media = $obj.hasClass('media_comment')?1:0;
		var ref = $obj.hasClass('ref_comment')?1:0;
		var del_id = $(this).attr('id').replace('comment_del_', '');
		confirmAction('Are you sure you want to delete this comment?', function() {
			$.post('profile/ajax/comments.cfm', {id:(id.replace('_alt', '')), media:media, ref:ref, del_id:(del_id.replace('_alt', ''))}, function(data) {
				$obj.find('.comments').html(data);
				initComments();	
			});
		});
	});
	
	$('.comment_edit').off('click').on('click', function() {	
		var $obj = $(this).closest('.rowComment-activity');
		$obj.find('.comment_edit_txt').show();
		$obj.find('.comment_view').hide();
		$obj.find('.comment_edit_txt textarea').css('height', 'auto');
		autosize.update($obj.find('.comment_edit_txt textarea'));
	});
	
	$('.activity_edit').off('click').on('click', function() {
		var $del = $(this);
		var $obj = $(this).closest('.activity-block');
		var $row = $obj.closest('.row');
		var id = $obj.attr('id').replace('activity_block_', '');
		openProfileDialog('Edit Comment', 'activity_edit.cfm?id=' + id, 500);
	});
	
	$('.btn_activity_edit').off('click').on('click', function() {
		showStatus('activity_edit_status', 'Saving Changes ...');
		var id = $('#f_activity_edit #id').val();
		var params = $('#f_activity_edit').serialize();
		$.post('profile/ajax/activity_edit.cfm' + reMember('?'), params, function(data) {
			showStatus('activity_edit_status', data.ERROR, (data.VALID)?'ok':'error');
			if (data.VALID) {
				$('#activity_block_' + id + ' .activity-description').html(data.DESC);
				initAssets();
				setTimeout(function() { closeDialog(); }, 3000);
			}
		}, 'json' );
	});
	
	$('.activity_del').off('click').on('click', function() {
		var $del = $(this);
		var $obj = $(this).closest('.activity-block');
		var $row = $obj.closest('.row');
		var id = $obj.attr('id').replace('activity_block_', '');
		confirmAction('Are you sure you want to delete this item?', function() {
			addLoading($del, 'Deleting');
			$.post('profile/ajax/' + (($del.hasClass('class_activity_del'))?'class_':'') + 'activity_del.cfm', {id:id}, function(data) {
				if (data.VALID) {
					if ($row.find('.activity-block').length > 1) {
						$obj.slideUp(500, function() {
							$obj.remove();
						});
					}
					else {
						$row.slideUp(500, function() {
							$row.remove();
						});
					}
				}
				else {
					showAlert(data.ERROR);
					removeLoading($del);
				}
			}, 'json');
		});
	});
	

	
	$('.activity_pin').off('click').on('click', function() {
		var $pin = $(this);
		var $obj = $(this).closest('.activity-block');
		var $row = $obj.closest('.row');
		var id = $obj.attr('id').replace('activity_block_', '');
		confirmAction('This item will be pinned to the top of the What\'s New page for the next 30 days.', function() {
			addLoading($pin.parent(), 'Pinning to top…');
			$.post('profile/ajax/activity_pin.cfm', {id:id}, function(data) {
				if (data.VALID) {
					if (data.HTM) {
						$('.announcement-feed').html(data.HTM);
						initAssets();
						preInitComments();
					}
				}
				else {
					showAlert(data.ERROR);
					removeLoading($pin.parent());
				}
			}, 'json');
		}, true);
	});
	
	$('.activity_unpin').off('click').on('click', function() {
		var $pin = $(this);
		var $obj = $(this).closest('.activity-block');
		var $row = $obj.closest('.row');
		var id = $obj.attr('id').replace('activity_block_', '');
		addLoading($pin.parent(), 'Unpinning…');
		$.post('profile/ajax/activity_pin.cfm', {id:id, unpin:1}, function(data) {
			if (data.VALID) {
				if (data.HTM) {
					$('.announcement-feed').html(data.HTM);
					initAssets();
					preInitComments();
				}
			}
			else {
				showAlert(data.ERROR);
				removeLoading($pin.parent());
			}
		}, 'json');
	});
	
	
	$('.profile_comment_del').off('click').on('click', function() {
		var $del = $(this);
		var $obj = $(this).closest('.activity-block');
		var $row = $obj.closest('.row');
		var id = $obj.attr('id').replace('activity_block_', '');
		confirmAction('Are you sure you want to delete this comment?', function() {
			addLoading($del, 'Deleting');
			$.post('profile/ajax/profile_comment_del.cfm', {id:id}, function(data) {
				if (data.VALID) {
					if ($row.find('.activity-block').length > 1) {
						$obj.slideUp(500, function() {
							$obj.remove();
						});
					}
					else {
						$row.slideUp(500, function() {
							$row.remove();
						});
					}
				}
				else {
					showAlert(data.ERROR);
					removeLoading($del);
				}
			}, 'json');
		});
	});
		
	$('.show-more-desc').off('click').on('click', function() {
		console.log('show more ...')
		$obj = $(this).parent().find('div, span')
		$obj.css('display', 'inline');
		$obj.show();
		$(this).remove();
	});
	
	//$('.autogrow').autogrow().removeClass('autogrow');
	autosize($('.autogrow'));
	$('.autogrow').removeClass('autogrow');
	
	initLike();
}

var $like_obj;
var $like_comment_obj;

function initLike() {
	$('.btn-like').off('click').on('click', function() {
		var $obj = $(this).closest('.comments-block');
		$like_obj = $obj;
		var id = $obj.attr('id').replace('comments_block_', '');
		var media = $obj.hasClass('media_comment')?1:0;
		var ref = $obj.hasClass('ref_comment')?1:0;
		$.post('profile/ajax/like.cfm', {id:(id.replace('_alt', '')), media:media, ref:ref}, function(data) {
			if (data.VALID) {
				$obj.find('.like').html(data.RET);
				initLike();
			}	
			else {
				showLikeAlert(data.ERROR);
				initLike();
			}
		}, 'json');
	});
	$('.btn-likes').off('click').on('click', function() {
		var $obj = $(this).closest('.comments-block');
		var id = $obj.attr('id').replace('comments_block_', '');
		var media = $obj.hasClass('media_comment')?1:0;
		var ref = $obj.hasClass('ref_comment')?1:0;
		openProfileDialog('Likes', 'likes.cfm?id=' + (id.replace('_alt', '')) + '&media=' + media + '&ref=' + ref, 500);
	});

	$('.btn-like-comment').off('click').on('click', function() {
		var $obj = $(this).closest('.rowComment-activity');
		$like_comment_obj = $obj;
		var c_id = $obj.attr('id').replace('member_comment_', '');
		$.post('profile/ajax/like.cfm', {c_id:c_id}, function(data) {
			if (data.VALID) {
				$obj.find('.like-comment').html(data.RET);
				initLike();
			}
			else {
				showLikeAlert(data.ERROR);
				initLike();
			}
		}, 'json');
	});
	
	$('.btn-unlike').off('click').on('click', function(e) {
		e.preventDefault();
		$.post('profile/ajax/unlike.cfm', {id:$(this).attr('rel')}, function(data) {
			if (data.VALID) {
				$like_obj.find('.like').html(data.RET);
				BootstrapDialog.closeAll();
				initLike();
			}
		}, 'json');
	});
	
	$('.btn-unlike-comment').off('click').on('click', function(e) {
		e.preventDefault();
		$.post('profile/ajax/unlike.cfm', {id:$(this).attr('rel'), c:1}, function(data) {
			if (data.VALID) {
				$like_comment_obj.find('.like-comment').html(data.RET);
				BootstrapDialog.closeAll();
				initLike();
			}
		}, 'json');
	});
	
	$('.btn-likes-comment').off('click').on('click', function() {
		var $obj = $(this).closest('.rowComment-activity');
		var c_id = $obj.attr('id').replace('member_comment_', '');
		openProfileDialog('Likes', 'likes.cfm?c_id=' + c_id, 500);
	});
}

function showComments($o, show_all) {
	var $obj = $o.closest('.comments-block');
	var id = $obj.attr('id').replace('comments_block_', '');
	var media = $obj.hasClass('media_comment')?1:0;
	var ref = $obj.hasClass('ref_comment')?1:0;
	$.post('profile/ajax/comments.cfm', {id:(id.replace('_alt', '')), media:media, show_all:show_all, ref:ref}, function(data) {
		$obj.find('.comments').html(data);
		initComments();	
	});
}

function initProfileAssets() {
	
	initMemberSearch();
	initProfileUploads();
	
	$('.selectpicker').selectpicker();
	
	//$('.activity_edit, .activity_pin, .activity_unpin').addClass('btn btn-default btn-sm');
	//$('.activity_del, .profile_comment_del').addClass('btn btn-danger btn-sm');
	
	$('.global_alert').each(function() {
		showAlert($(this).text());
	});
	
	$('.show_new_item_popup').off('click').on('click', function() {
		$.get('profile/ajax/show_new_items_popup.cfm', {s:$(this).prop('checked')?0:1}, function(data) {
		});
	});
	
	
  //if ( $('#vid_tab').length) $('.tabs').tabs( { selected: 2 } );
	//else $(".tabs" ).tabs();
	
	$('#message_send2').on("click", function() {		
		//confirmAction('Are you sure you want to send this message now?');
		showStatus('message_status2', 'Sending message ...');
		postJSON('profile/ajax/contact.cfm', {parent_message_id:getVal('parent_message_id2'), member_id:$('#member_id2').val(), message:getVal('message2')}, 'message_status2', function(data) {
			resetField('message2');
			$('#member_id2').val(0);
			if ( getVal('parent_message_id2') > 0) {
				getMessage(data.ID, data.PID);
			}
			setTimeout(function() { closeDialog(); }, 2000);
		});
	});
	
	$('#message_send').off("click").on("click", function() {		
		//confirmAction('Are you sure you want to send this message now?');
		showStatus('message_status', 'Sending message ...');
		postJSON('profile/ajax/contact.cfm', {parent_message_id:getVal('parent_message_id'), recipient_id:$('#member_id').val(), first_name:getVal('message_first_name'), last_name:getVal('message_last_name'), email:getVal('message_email'), subject:getVal('message_subject'), message:getVal('message')}, 'message_status', function(data) {
			resetField('message_first_name');
			resetField('message_last_name');
			resetField('message_email');
			resetField('message');
			resetField('message_subject');
			//$('#member_id').val(0);
			if ( getVal('parent_message_id') > 0) {
				getMessage(data.ID, data.PID);
			}
			setTimeout(function() { $('#message_status').hide(); $('.contact_message').slideUp('slow'); closeDialog(); }, 2000);
		});
	});
	
	$('#btn_contact_admin').on("click", function() {		
		//confirmAction('Are you sure you want to send this message now?');
		showStatus('contact_admin_status', 'Sending message ...');
		postJSON('profile/ajax/contact-admin.cfm', {subject:getVal('subject'), message:getVal('message')}, 'contact_admin_status', function(data) {
			if (data.VALID) {
				resetField('subject');
				resetField('message');
			}
		});
	});
	
	$('.adminButton>a').off('click').on('click', function() {
		openProfileDialog('Ready to become Class Administrator?', 'become-administrator.cfm', 500);
	});
	
	$('#btn_administrator').off('click').on('click', function() {
		$('.ba-btns').hide();
		showStatus('status_become_administrator', 'Processing request ...');
		becomeAdmin();
	});

	$('.form-field').focus(function() {
		if ($(this).val() == $(this).attr('title') ) {
			$(this).val('');
			$(this).removeClass('faded')
		}
	});
	$('.form-field').blur(function() {
		if ($(this).val() == '' || $(this).val() == $(this).attr('title') ) {
			$(this).val( $(this).attr('title') );
			$(this).addClass('faded');
		}
	});
	$('.form-field').off('keydown').on('keydown', function (event) {		
		if ($(this).val() == $(this).attr('title') ) {
			$(this).val('');
			$(this).removeClass('faded')
		}
	});
	
	$('.image_btn_remove').off('click').on('click', function() {
		var id = $(this).closest('.imageHolder').attr('id');
		if ($(this).hasClass('media_del_btn')) {
			var $obj = $(this).closest('.media_item');
			id = $obj.attr('id').replace('photo_', '');
			id = id.replace('video_', '');
			var type = $obj.hasClass('fb_photo')?1:2;
			confirmAction('<div style="width:50px;height:50px;overflow:hidden;float:left;margin-right:10px"><img width="50" src="' + $obj.find('img').attr('src') + '" /></div><div class="f-left"><b>Delete this ' + ((type == 1)?'image':'video') + '?</b><br />It will be permanently removed from your gallery.</div><div class="clr"></div>', function() {
				$.post('profile/ajax/media_save_detail.cfm', {id:id, del:1, t:type, re_member_id:$('#re_member_id').val()}, function(data) {
					if (type == 1) {
						$('#photos1').html(data.PHOTO_IMG);
						$('#photos2').html(data.PHOTO_COUNT);
					}
					else {
						$('#videos1').html(data.PHOTO_IMG);
						$('#videos2').html(data.PHOTO_COUNT);
					}
					updateImageEditBtns();
				}, 'json');
				$obj.fadeOut(500, function() { $(this).remove();})
			});
		}
		else {
			addLoading($('#' + id + ' .img'), 'Removing ...', 'loading', true);
			$('.cropper').hide();
			var t = (!isNaN($(this).attr('rel'))?($(this).attr('rel')):'');
			$.post('profile/ajax/media_remove.cfm', {t: t, re_member_id:$('#re_member_id').val()}, function(data) {
				if (data.VALID) { 
					$('#' + id + ' .img').html(data.IMG);
					updateImageEditBtns();
				}
				else {
					showAlert(data.ERROR);
					removeLoading($('#' + id + ' .img'));
				}
			}, 'json');
		}
	});
	
	$('.image_btn_select').off('click').on('click', function() {
		openProfileDialog('Select Profile Photo', 'media.cfm' + ((!isNaN($(this).attr('rel')))?('?t=' + $(this).attr('rel')):'?show=1') + reMember('&'));
		imageHolder = $(this).closest('.imageHolder').attr('id');
	});
	
	$('.image_btn_edit').off('click').on('click', function() {
		var src = $(this).closest('.imageHolder').find('img').attr('rel');
		var id = $(this).closest('.imageHolder').find('img').attr('id');
		if ($(this).hasClass('media_edit_btn')) {
			$('.media_detail').html('');
			addLoading($('.media_detail'), 'Loading image ...', 'msg');
			$('.media_detail').slideDown(100);
			id = $(this).closest('.media_item').attr('id').replace('photo_', '');
			id = id.replace('video_', '');
			var type = $(this).closest('.media_item').hasClass('fb_photo')?1:2;
			$.get('profile/ajax/media_detail.cfm', {id:id, t:type, re_member_id:$('#re_member_id').val()}, function(data) {
				$('.media_detail').html(data);
				$('.media_detail').slideDown(500);
				initAssets();
			});
		}
		else if ($(this).hasClass('video_edit_btn')) {
		}
		else {
			//launchEditor(id, src);
		}
	});
	
	$('#btn_new_video').off('click').on('click', function() {
		$('.video_upload_block').slideDown(500);
	});
	$('#btn_close_new_video').off('click').on('click', function() {
		$('.video_upload_block').slideUp(200);
	});
	
	$('.btn_media_detail_cancel').off('click').on('click', function() {
		$('.media_detail').slideUp(200, function() { $('.media_detail').html(''); } );
	});
	
	$('.btn_media_detail_del').off('click').on('click', function() {
		var id = getVal('media_detail_id');
		var type = getVal('media_detail_type_id');
		var $obj = $('#' + ((type == 1)?'photo':'video') + '_' + id);
		confirmAction('<div style="width:50px;height:50px;overflow:hidden;float:left;margin-right:10px"><img width="50" src="' + $obj.find('img').attr('src') + '" /></div><div class="f-left"><b>Delete this ' + ((type == 1)?'image':'video') + '?</b><br />It will be permanently removed from your gallery.</div><div class="clr"></div>', function() {
			$.post('profile/ajax/media_save_detail.cfm', {id:id, t:type, del:1, re_member_id:$('#re_member_id').val()}, function(data) {
				if (type == 1) {
					$('#photos1').html(data.PHOTO_IMG);
					$('#photos2').html(data.PHOTO_COUNT);
				}
				else {
					$('#videos1').html(data.PHOTO_IMG);
					$('#videos2').html(data.PHOTO_COUNT);
				}
				updateImageEditBtns();
			}, 'json');
			$('.media_detail').slideUp(100, function() { $('.media_detail').html(''); } ); $obj.fadeOut(500, function() { $(this).remove();})
		});
	});
	
	$('.btn_media_detail_save').off('click').on('click', function() {
		var id = getVal('media_detail_id');
		var type = getVal('media_detail_type_id');
		showStatus('media_detail_status', 'Saving details ...');
		postJSON('profile/ajax/media_save_detail.cfm', {id:id, t:type, title:getVal('media_title'), desc:getVal('media_description'), re_member_id:$('#re_member_id').val()}, 'media_detail_status', function(data) {
			setTimeout(function() { $('.media_detail').slideUp(200, function() { $('.media_detail').html(''); } ); }, 3000);
		});
	});
	
	$('.btn-member-activity-media-all').off('click').on('click', function() {
		$(this).hide();
		$('.member-activity-media-all').slideDown(1000);
	});
	
	$('.announcement_attachment_video').off('click').on('click', function() {
		$curr_video_o = $(this).closest('.row-Recent-Activity');
		openDialog('Attach Video', 'profile/dialog/video_attach.cfm');
	});
	
	$('.btn_announcement_attachment_video').off('click').on('click', function() {
		var $f = $('#announcement_attachment_video_link_input');
		if ($f.val().length) {
			showStatus('announcement_video_status', 'Adding video ...');
			postJSON('profile/ajax/media_yt.cfm', {l:$f.val(), g:0, re_member_id:$('#re_member_id').val()}, 'announcement_video_status', function(data) {
				$f.val('');
				$curr_video_o.find('.comment-form .comment_attachment').show();
				$curr_video_o.find('.announcement_attachments_block').show();
				$curr_video_o.find('.announcement_attachments').append('<div id="member_media_' + data.MEMBER_MEDIA_ID + '" class="announcement_attachment_media"><div class="announcement_attachment_clip"></div><img src="' + data.THUMBNAIL + '" /><a href="javascript:void(0)" class="announcement_attachment_remove btn btn-danger btn-sm"><i class="fa fa-trash"></i></a></div>');
				closeDialog();
				initAssets();
			});
		}
		else {
			showStatus('announcement_video_status', 'Please paste link to Youtube or Vimeo video in the field.', 'error');
		}
	});
	
	
	$('.image_btn_adjust').off('click').on('click', function() {
		var $img = $(this).closest('.media_item').find('img');
		var src = $img.attr('rel');
		launchEditor($img.attr('id'), src, 1)
	});
	
	$('.announcement_media_edit').off('click').on('click', function() {
		launchEditor('announcement_media_0', $('#announcement_media_url').val(), 1)
	});
	
	$('.announcement_attachment_edit').off('click').on('click', function() {
		var $img = $(this).closest('.announcement_attachment_media').find('img');
		var src = $img.attr('rel');
		launchEditor($img.attr('id'), src, 1)
	});
	
	$('.fb_album').off('click').on('click', function() {
		var id = $(this).attr('id').replace('album_', '');
		$('.fb_album').removeClass('selected');
		var $obj = $(this)
		$obj.addClass('selected');
		$('#folder_id').val(id);
		addLoading($obj, '', 'album');
		$.get('profile/dialog/media.cfm', {id:id, t:$(this).attr('rel'), a_m: getVal('a_m'), c_m: getVal('c_m'), re_member_id:$('#re_member_id').val()}, function(data) {
			$('.fb_photos_inner').html(data);
			if (id == 0) {
				$('.fb_photos_inner').addClass('sortable');			
			}
			else {
				$('.fb_photos_inner').removeClass('sortable');
			}
			removeLoading($obj);
			initAssets();
			/*.addClass('invisible)'
			setTimeout(function(){
				var $container = $('.fb_photos_inner');
				$container.imagesLoaded(function(){
					$container.masonry({
						isAnimated: false,
						isFitWidth: true,
						itemSelector : '.fb_photo'
					});
				});
				$('.fb_photos_inner').masonry( 'reload').removeClass('invisible'); 
			}, 1000);
			*/
		});
	});
	
	$('.announcement_attach').off('click').on('click', function() {
		openProfileDialog('Add Image or Video to message', 'announcement_media.cfm' + (($(this).hasClass('announcement_attach_video'))?'?t=2':''), 820);
	});
	
	$('.fb_photo_announcement img').off('click').on('click', function() {
		var id = $(this).parent().attr('id').replace('photo_', '');
		var src = $(this).attr('src');
		$('#announcement_media_type').val(1);
		$('#announcement_media_id').val(id);
		$('#announcement_media_url').val($('#fb_' + id + '_url').val().trim());
		$('#announcement_media_w').val($('#fb_' + id + '_w').val());
		$('#announcement_media_h').val($('#fb_' + id + '_h').val());
		$('#announcement_media_preview').html('<img id="announcement_media_0" src="' + src + '" alt="" />');
		$('.announcement_attachment').show();
		$('.announcement_attach').hide();
		$('.announcement_media_edit').show();
		$('.announcement_media_edit').attr('id', 'photo_edit_' + id);
		closeDialog();
		initAssets();
	});
	
	$('.video_item_announcement img').off('click').on('click', function() {
		var id = $(this).parent().attr('id').replace('video_', '');
		var src = $(this).attr('src');
		$('#announcement_media_type').val(2);
		$('#announcement_media_id').val(id);
		$('#announcement_media_url').val('');
		$('#announcement_media_w').val('');
		$('#announcement_media_h').val('');
		$('#announcement_media_preview').html('<img src="' + src + '" />');
		$('.announcement_attachment').show();
		$('.announcement_attach').hide();
		$('.announcement_media_edit').hide();
		closeDialog();
	});
	
	$('.announcement_attachment_remove').off('click').on('click', function() {
		var $div = $(this).closest('.announcement_attachment_media');
		var $o = $div.closest('.row-Recent-Activity');
		$div.fadeOut(500, function() { 
			$(this).remove() 
			if ($o.find('.announcement_attachment_media').length == 0) {
				$o.find('.comment-form .comment_attachment').hide();
				$o.find('.announcement_attachments_block').hide();
			}
		});	
	});
	
	$('.announcement_media_remove').off('click').on('click', function() {
		$('#announcement_media_type').val(0);
		$('#announcement_media_id').val('');
		$('#announcement_media_url').val('');
		$('#announcement_media_w').val('');
		$('#announcement_media_h').val('');
		$('#announcement_media_preview').html('');
		$('.announcement_attachment').hide();
		$('.announcement_attach').show();
	});
	
	$('.comment_attach').off('click').on('click', function() {
		$(this).hide();
		$(this).next().slideDown(500);
		//openProfileDialog('Add Image or Video to comment', 'comment_media.cfm?c_m=' + $(this).closest('.comments-block').attr('id').replace('comments_block_', '') + (($(this).hasClass('comment_attach_video'))?'&t=2':''), 820);
	});
	
	$('.fb_photo_comment img').off('click').on('click', function() {
		var c_id = $('#c_m').val();
		var $obj = $('#comments_block_' + c_id);
		var id = $(this).parent().attr('id').replace('photo_', '');
		var src = $(this).attr('src');
		$obj.find('.comment_media_type').val(1);
		$obj.find('.comment_media_id').val(id);
		$obj.find('.comment_media_preview').html('<img src="' + src + '" width="50" />');
		$obj.find('.comment_attachment').show();
		$obj.find('.comment_attach').hide();
		closeDialog();
	});
	
	$('.video_item_comment img').off('click').on('click', function() {
		var c_id = $('#c_m').val();
		var $obj = $('#comments_block_' + c_id);
		var id = $(this).parent().attr('id').replace('video_', '');
		var src = $(this).attr('src');
		$obj.find('.comment_media_type').val(2);
		$obj.find('.comment_media_id').val(id);
		$obj.find('.comment_media_preview').html('<img src="' + src + '" width="50" />');
		$obj.find('.comment_attachment').show();
		$obj.find('.comment_attach').hide();
		closeDialog();
	});
	
	$('.comment_media_remove').off('click').on('click', function() {
		var $obj = $(this).closest('.comments-block');
		$obj.find('.comment_media_type').val('1');
		$obj.find('.comment_media_id').val('');
		$obj.find('.comment_media_preview').html('');
		$obj.find('.comment_attachment').hide();
		$obj.find('.comment_attach').show();
	});
	
	$('.fb_photo_sel img').off('click').on('click', function() {
		var id = $(this).parent().attr('id').replace('photo_', '');
		var type = $('#fb_' + id + '_type').val();
		var url = $('#fb_' + id + '_url').val();
		var w = $('#fb_' + id + '_w').val();
		var h = $('#fb_' + id + '_h').val();
		var img = '<img rel="0" id="image' + type + '" src="' + url + '" width="100%" alt="" />';
		var img_cropper = '<img rel="0" id="image' + type + '_cropper" src="' + url + '" alt="" />';
		var loading = '<div class="status photo-loading">Loading ...</div>';
		
		if (imageHolder) {
			addLoading($('#' + imageHolder + ' .img'), 'Loading', 'loading', true);
		}
				
		$.post('profile/ajax/media_save.cfm', {type:type, id: id, url:url, w:w, h:h, re_member_id:$('#re_member_id').val()}, function(data) {
			if (data.VALID) {
				if (data.MEMBER_MEDIA_ID) {
					saveActivity(type, 0, data.MEMBER_MEDIA_ID);
				}
				if (imageHolder) {
					$('#' + imageHolder + ' .img').html(img);
				}
				launchCropEditor('image' + type, data.LARGE, type);
				//openProfileDialog('Adjust Thumbnail', 'thumbnail.cfm?t=' + type + reMember('&'), 1000);
			}
			else {
				showAlert(data.ERROR);
				$('.photo-loading').remove();
			}
			updateImageEditBtns();
		}, 'json');

		closeDialog();
	});
	
	//
	$('.fb_photo_gallery img, .video_item img, .check').off('click').on('click', function() {
		$obj = $(this).parent();
		$obj.toggleClass('selected');
		var id = $obj.attr('id').replace('photo_', '');
		var id = id.replace('video_', '');
		var type = (($obj.hasClass('fb_photo'))?1:2);
		var url = ((type == 1)?($('#fb_' + id + '_url').val()):'');
		var w = ((type == 1)?($('#fb_' + id + '_w').val()):'0');
		var h = ((type == 1)?($('#fb_' + id + '_h').val()):'0');
		var fn = $obj.hasClass('selected')?'media_select':'media_deselect';
		$.post('profile/ajax/' + fn + '.cfm', {type:type, id: id, url:url, w:w, h:h, re_member_id:$('#re_member_id').val()}, function(data) {
			if (type == 1) {
				$('#photos1').html(data.PHOTO_IMG);
				$('#photos2').html(data.PHOTO_COUNT);
			}
			else {
				$('#videos1').html(data.PHOTO_IMG);
				$('#videos2').html(data.PHOTO_COUNT);
			}
			updateImageEditBtns();
		}, 'json');
	});
	
	
	
	
	$('.photos_slideshow').off('click').on('click', function() {
		openProfileDialog($('#member_first_name').val() + ' Photo Gallery', 'slideshow2.cfm?m_id=' + getVal('member_id') + '&id=' + $(this).attr('id').replace('photo_', '') + '&type=1' + reMember('&'), 900);
	});
	$('.main_photos_slideshow').off('click').on('click', function() {
		openProfileDialog($('#member_first_name').val() + ' Photo Gallery', 'slideshow2.cfm?m_id=' + getVal('member_id') + '&id=0&type=1' + reMember('&'), 900);
	});
	$('.main_videos_slideshow').off('click').on('click', function() {
		openProfileDialog($('#member_first_name').val() + ' Video Gallery', 'slideshow2.cfm?m_id=' + getVal('member_id') + '&id=0&type=2' + reMember('&'), 900);
	});

	$('.video_dialog').off('click').on('click', function() {
		var t = $(this).attr('rel');
		t = (t.length > 0)?t:'Video';
		openProfileDialog(t, 'video.cfm?id=' + $(this).attr('id').replace('video_', '') + reMember('&'), 740);
	});
	
	$('.contact_member').off('click').on('click', function() {
		if ($('.contact_message').length) {
			$('.contact_message').slideToggle('slow');
		}
		else {
			openProfileDialog($(this).text(), 'contact_member.cfm', 710);
		}
	});
	
	$('.message').off('click').on('click', function() {
		$obj = $(this);
		$('.message').parent().removeClass('selected');
		$obj.parent().addClass('selected');
		var id = $obj.attr('id').replace('message_', '');
		var pid = $obj.attr('rel');
		if (!showMessage) {
			$('.message_list').animate({width:'40%'}, 500, function() {
				if (!$obj.hasClass('member_notification')) {
					getMessage(id, pid);
				}
				else {
					getNotification(id);
				}
			});
		}
		else {
			if (!$obj.hasClass('member_notification')) {
				getMessage(id, pid);
			}
			else {
				getNotification(id);
			}
		}
	});
	
	$('.message_del').off('click').on('click', function() {
		var $obj = $(this);
		var id = $obj.attr('id').replace('message_del_', '');
		if ($obj.hasClass('message_del')) {
			confirmAction('Are you sure you want to delete this notification?', function() { postJSON('profile/ajax/notification_del.cfm', {id:id}, '', function(data) { $obj.closest('li').remove(); }); });
		}
		else {
			confirmAction('Are you sure you want to move this message to recycling bin?', function() { postJSON('profile/ajax/message_del.cfm', {id:id}, '', function(data) { $obj.closest('li').remove(); }); });
		}
	});
	
	$('.message_options>span').off('click').on('click', function() {
		var $obj = $(this);
		$('.message_options>span').removeClass('selected');
		$obj.addClass('selected');
		if ($obj.hasClass('message_notifications')) {
			showStatus('message_body_status', 'Loading notifications ...');
			$.post('profile/ajax/notifications.cfm', {}, function(data) {
				$('.message_list').html(data);
				initAssets();
				hideStatus('message_body_status');
			});
		}
		else {
			showStatus('message_body_status', 'Loading messages ...');
			if ($obj.hasClass('message_sent')) {
				$.post('profile/ajax/messages.cfm', {my_messages:1}, function(data) {
					$('.message_list').html(data);
					initAssets();
					hideStatus('message_body_status');
				});
			}
			else if ($obj.hasClass('message_bin')) {
				$.post('profile/ajax/messages.cfm', {bin:1}, function(data) {
					$('.message_list').html(data);
					initAssets();
					hideStatus('message_body_status');
				});			
			}
			else if ($obj.hasClass('message_inbox')) {
				$.post('profile/ajax/messages.cfm', {}, function(data) {
					$('.message_list').html(data);
					initAssets();
					hideStatus('message_body_status');
				});			
			}
			else if ($obj.hasClass('message_compose')) {
				if (!showMessage) {
					$('.message_list').animate({width:'40%'}, 500, function() {
						getMessage(0);		
					});
				}
				else {
					getMessage(0);
				}
			}
		}
	});
	
	
	$('.message_compose').off('click').on('click', function() {
		openProfileDialog('Compose New Message', 'message_new.cfm', 450);
	});
	
	$('.btn_non_classmate').off('click').on('click', function() {
		showStatus('non_classmate_status', 'Sending Information ...');
		var $obj = $(this);
		var id = $(this).attr('id').replace('btn_non_classmate_', '');
		$.post('profile/ajax/non_classmate.cfm', {id:$('#member_id').val()}, function(data) {
			if (data.VALID) {
				$('.non-classmate-block').html(data.ERROR);
			}
			else {
				showStatus('non_classmate_status', data.ERROR, (data.VALID)?'ok':'error');
			}
		}, 'json');
	});
	
	$('.duplicate_member_name').off('click').on('click', function() {
		var id = $(this).attr('id').replace('duplicate_member_name_', '');
		$('#duplicate_member_creds_' + id).slideDown(500);
	});
	
	$('.duplicate_member_creds_closer').off('click').on('click', function() {
		var id = $(this).attr('id').replace('duplicate_member_creds_closer_', '');
		$('#duplicate_member_creds_' + id).hide();
		$('#duplicate_member_status_' + id).hide();
	});
	
	
	$('.btn_duplicate_member').off('click').on('click', function() {
		var id = $(this).attr('id').replace('duplicate_member_', '');
		showStatus('duplicate_member_status_' + id, 'Sending verification ...');
		$('#duplicate_member_btn').hide();
		$('.duplicate_member_block').not($('#duplicate_member_block_' + id)).hide();
		$.post('profile/ajax/duplicate.cfm', {member_id:id, verify_email:1}, function(data) {
			showStatus('duplicate_member_status_' + id, data.ERROR, (data.VALID)?'ok':'error', true);
			if (data.VALID) {
				$('#duplicate_member_creds_' + id).hide();
			}
			initAssets();
		}, 'json');
	});
	
	$('.btn_merge_member').off('click').on('click', function() {
		var id = $(this).attr('id').replace('merge_member_', '');
		showStatus('duplicate_member_status_' + id, 'Joining Class ...');
		$('#merge_member_btn').hide();
		$('.duplicate_member_block').not($('#duplicate_member_block_' + id)).hide();
		$.post('profile/ajax/duplicate.cfm', {member_id:id, merge:1}, function(data) {
			showStatus('duplicate_member_status_' + id, data.ERROR, (data.VALID)?'ok':'error', true);
			if (data.VALID) {
				setTimeout(function() { location.href='/welcome.cfm'; }, 2000);
			}
		}, 'json');
	});
	
	$('.btn_duplicate_member_password').off('click').on('click', function() {
		var id = $(this).attr('id').replace('duplicate_member_password_', '');
		showStatus('duplicate_member_status_' + id, 'Verifing password ...');
		$('#duplicate_member_btn').hide();
		$('.duplicate_member_block').not($('#duplicate_member_block_' + id)).hide();
		$.post('profile/ajax/duplicate.cfm', {member_id:id, password:$('#duplicate_member_password_' + id).val()}, function(data) {
			showStatus('duplicate_member_status_' + id, data.ERROR, (data.VALID)?'ok':'error', true);
			if (data.VALID) {
				$('#duplicate_member_creds_' + id).hide();
			}
		}, 'json');
	});
	
	$('.try_password').off('click').on('click', function() {
		var id = $(this).attr('id').replace('try_password_', '');
		hideStatus('duplicate_member_status_' + id);
		$('#duplicate_member_block_' + id).find('.duplicate_col2, .duplicate_col3').hide();
		$('#duplicate_member_block_' + id).show();
		$('#duplicate_member_creds_' + id).slideDown(500);
	});
	
	$('#btn_welcome_message').off('click').on('click', function() {
		$(this).parent().hide();
		var $obj = $(this).closest('.nextStep');
		showStatus('welcome_message_status', 'Sending ...');
		postJSON('profile/ajax/welcome-send.cfm', {}, 'welcome_message_status', function(data) {

			setTimeout(function() {				
				$obj.slideUp('500', function() {
					$obj.remove();
					var i = 0;
					$('.nextStep').each(function() {
						$(this).find('h6').html((++i) + '.');
					});
					if ( $('.nextStep').length == 0) {
						// what to do if all done?
					}
				});
			}, 2000);
		});
	});
	
	$('#btn_timeline_perm').off('click').on('click', function() {
		getTimelinePermission();
	});
	
	
	
	$('.photos_gallery').off('click').on('click', function() {
		openProfileDialog('Photo Gallery','media.cfm?t=1' + reMember('&') );
	});
	
	$('.videos_gallery').off('click').on('click', function() {
		openProfileDialog('Video Gallery','videos.cfm?t=2' + reMember('&') );
	});
	
	$('#btn_feedback').off('click').on('click', function() {
		showStatus('feedback_status', 'Sending ...');
		postJSON('profile/ajax/feedback.cfm', {type:getVal('feedback_type'), message:getVal('feedback_message')}, 'feedback_status', function(data) {
			setTimeout(function() {
				closeDialog();
			}, 2000);
		});
	});
	
	/* +++++++++++++ FB +++++++++++++++++++++ */
	
	$('#f_fb_group').off('submit').on('submit', function() {
		var key = getVal('fb_group');
		if (key.length > 0) {
			$('#fb_group_content').html('');
			showStatus('fb_group_status', 'Searching ...');
			$.post('profile/ajax/fb_group.cfm', {key:key}, function(data) {
				if (data.length) {
					hideStatus('fb_group_status');
					$('#fb_group_content').html(data);
					initAssets();
				}
				else {
					showStatus('fb_group_status', 'No facebook groups found', 'error');
				}
			});
		}
		else {
			showStatus('fb_group_status', 'Please enter a name to search', 'error');
		}
	});
	
	$('#btn_fb_group_more').off('click').on('click', function() {
		var key = getVal('fb_group');
		var start = getVal('fb_group_start');
		if (key.length > 0) {
			showStatus('fb_group_status', 'Searching ...');
			$('#fb_group_more').remove();
			$.post('profile/ajax/fb_group.cfm', {key:key, start:start}, function(data) {
				if (data.length) {
					hideStatus('fb_group_status');
					$('#fb_group_content').append(data);
					initAssets();
				}
			});
		}
		else {
			showStatus('fb_group_status', 'Please enter a group name to search', 'error');
		}
	});
	
	$('#btn_fb_members_more').off('click').on('click', function() {
		var id = getVal('fb_group_id');
		var start = getVal('fb_members_start');
		if (id.length > 0) {
			showStatus('fb_members_status', 'Searching ...');
			$('#fb_members_more').remove();
			$.get('profile/dialog/fb_group.cfm', {id:id, start:start}, function(data) {
				if (data.length) {
					hideStatus('fb_members_status');
					$('#fb_members_content').append(data);
					initAssets();
				}
			});
		}
		else {
			showStatus('fb_members_status', 'Please enter a group name to search', 'error');
		}
	});
	
	$('.group_request').off('click').on('click', function() {
		var id = $(this).attr('id').replace('group_request_', '');
		openProfileDialog($(this).closest('label').find('.thumbFBName').text(), 'fb_group.cfm?id=' + id, 740, 600);
	});
	
	$('#f_fb_people').off('submit').on('submit', function() {
		var key = getVal('fb_people');
		if (key.length > 0) {
			$('#fb_people_content').html('');
			showStatus('fb_people_status', 'Searching ...');
			$.post('profile/ajax/fb_people.cfm', {key:key}, function(data) {
				if (data.length) {
					hideStatus('fb_people_status');
					$('#fb_people_content').html(data);
					initAssets();
				}
				else {
					showStatus('fb_people_status', 'No facebook users found', 'error');
				}
			});
		}
		else {
			showStatus('fb_people_status', 'Please enter a name to search', error);
		}
	});
	
	$('#btn_fb_people_more').off('click').on('click', function() {
		var key = getVal('fb_people');
		var start = getVal('fb_people_start');
		if (key.length > 0) {
			showStatus('fb_people_status', 'Searching ...');
			$('#fb_people_more').remove();
			$.post('profile/ajax/fb_people.cfm', {key:key, start:start}, function(data) {
				if (data.length) {
					hideStatus('fb_people_status');
					$('#fb_people_content').append(data);
					initAssets();
				}
			});
		}
		else {
			showStatus('fb_people_status', 'Please enter a name to search', error);
		}
	});
	
	$('.friend_request').off('click').on('click', function() {
		var id = $(this).attr('id').replace('friend_request_', '');
		FB.ui({ method: 'friends.add', id: id, display : 'popup' });
	});
	
	$('.sortable').sortable({
		helper:	'clone',
		items: '.fb_photo, .video_item', //'li.active',
		opacity: .8,
		placeholder: 'dragPlaceholder',
		errorClass: 'dragError',
		tolerance: "intersect",
		cursor: 'move',
		//revert: 250,
		//tabSize: 25,
		//tolerance: 'pointer',
		//toleranceElement: '> div',
		//maxLevels: 3,
		update: function(event, ui) {
			var s = $(this).sortable('toArray').toString().replace(/photo_/g, '')
			s = s.replace(/video_/g, '');
			var t = (($('.fb_photo').length)?1:2);
			$.post('profile/ajax/media_sort.cfm', {s:s, t:t , re_member_id:$('#re_member_id').val()}, function(data) {
				if (t == 1) {
					$('#photos1').html(data.PHOTO_IMG);
					$('#photos2').html(data.PHOTO_COUNT);
				}
				else {
					$('#videos1').html(data.PHOTO_IMG);
					$('#videos2').html(data.PHOTO_COUNT);
				}
				updateImageEditBtns();
			}, 'json');
		}
	});
	
	$('.announcement_attachments').sortable({
		helper:	'clone',
		items: '.announcement_attachment_media',
		opacity: .8,
		placeholder: 'dragPlaceholder',
		errorClass: 'dragError',
		tolerance: "intersect",
		cursor: 'move'
	});
	
	$('#btn_video_link').off('click').on('click', function() {
		showStatus('video_link_status', 'Adding video ...');
		postJSON('profile/ajax/media_yt.cfm', {l:getVal('video_link'), t:getVal('video_link_title'), d:getVal('video_link_description'), re_member_id:$('#re_member_id').val()}, 'video_link_status', function(data) {
			resetField('video_link');
			resetField('video_link_description');
			$.get('profile/ajax/videos.cfm', {a_m: getVal('a_m'), c_m: getVal('c_m'), re_member_id:$('#re_member_id').val()}, function(data) {
				$('#video_list').html(data);
				$('.video_upload_block').slideUp(200);
				galleryPreview(2);
				initAssets();
			});
		});
	});
	
	//$('.gallery_anchor').off('click').on('click', function() {
		//return scrollToAnchor($(this));
	//});
	
	$('.toggle_comments').off('click').on('click', function() {
		var $obj = $(this).closest('.parent-block');
		if ( $(this).html() == '<i class="fa fa-comments"></i> Hide Comments' ) {
			$obj.find('.comments-block').hide();
			$(this).addClass('comments_down');
			$(this).html('<i class="fa fa-comments"></i> Show Comments');
		}
		else {
			$obj.find('.comments-block').show();
			$(this).removeClass('comments_down');
			$(this).html('<i class="fa fa-comments"></i> Hide Comments');			
		}
	});

		
	$('.show-more-desc').off('click').on('click', function() {
		console.log('show more ...')
		$obj = $(this).parent().find('div, span')
		$obj.css('display', 'inline');
		$obj.show();
		$(this).remove();
	});

	initComments();
}

function defaultProfileAssets() {
	
	featherEditor = new Aviary.Feather({
		apiKey: '2f8eb5d31daf4a8b98c659f967716e37',
		//tools: ['draw', 'stickers'],
		maxSize: 1200,
		onSave: function(imageID, imageURL) {
			featherEditor.showWaitIndicator();
			var $i = $('#' + imageID);
			var id = ($('#announcement_media_id').length)?$('#announcement_media_id').val():(imageID.replace('photo_', ''));
			id = id.replace('member_media_', '');
			$.ajax({
				url: 'profile/ajax/save_editor_image.cfm',
				data: {type:featherEditorType, url:imageURL, re_member_id:$('#re_member_id').val(), id:id},
				method: 'post',
				dataType: 'json',
				success: function(data, textStatus, jqXHR) {
					if (data.VALID) {
						$i.attr('src', data.THUMBNAIL);
						$i.attr('rel', data.LARGE);
						if ($('.announcement_attachments').length) {
							$i.attr('id', 'photo_' + data.ID);
							$i.closest('.announcement_attachment_media').attr('id', 'member_media_' + data.MEMBER_MEDIA_ID);
						}
						else {
							//$i.attr('id', 'member_media_' + data.ID);
							//$i.closest('.media_item').attr('id', 'photo_' + data.ID);
						}
						featherEditor.hideWaitIndicator();
						featherEditor.close();
					}
					else {
						showAlert(data.ERROR);
					}
				},
				error: function(jqXHR, textStatus, errorThrown) {
					featherEditor.hideWaitIndicator();
					featherEditor.close();
					showAlert('Something went wrong while saving your image. Please wait a few minutes and try again.');
				}
			});
		}
	});
	
	if ($('.new_profile_msg').length) {
		openProfileDialog('Profile updated since your last visit', 'profile_new_msg.cfm?n=' + encodeURI($('#member_first_name').val()), 400);
	}
	
	if ($('.new_profile_entry').length) {
		$('#new_profile_entry').show();
	}
	
	if ($('#attending_reunion').length > 0) {
		$('#reunion-attend-status').removeClass('hide');
	}
	
	if ($('#questions_and_answers').closest('.parent-block').find('.rowBio').length == 0) {
		$('#questions_and_answers').closest('.parent-block').hide();
	}
	
	$('.announcement-feed div.row').each(function() {
		$('#recent_messages_block').removeClass('hide');
		if ($('.announcement-feed div.row').length < 4) {
			$('#more-announcements').hide();
		}
	});
	
	$('input[name=classmate_sort1]').off('click').on('click', function() {
		var $obj = $(this).closest('.statusBox');
		$('.statusBox').not($obj).removeClass('statusBoxOn');
		$obj.addClass('statusBoxOn');
		showStatus('classmate_list_status', 'Updating classmate list ...');
		$.get('profile/ajax/classmates.cfm?r=' + Math.random(), {sort1: $(this).val()}, function(data) {
			hideStatus('classmate_list_status');
			$('.classmate_list').html(data);
		});
	});
	$('input[name=classmate_sort2]').off('click').on('click', function() {
		showStatus('classmate_list_status', 'Updating classmate list ...');
		$.get('profile/ajax/classmates.cfm?r=' + Math.random(), {sort2: $(this).val()}, function(data) {
			hideStatus('classmate_list_status');
			$('.classmate_list').html(data);
		});
	});
	$('input[name=classmate_sort3]').off('click').on('click', function() {
		showStatus('classmate_list_status', 'Updating classmate list ...');
		$.get('profile/ajax/classmates.cfm?r=' + Math.random(), {sort3: $(this).prop('checked')?1:0}, function(data) {
			hideStatus('classmate_list_status');
			$('.classmate_list').html(data);
		});
	});
	$('#classmate_yp').off('click').on('click', function() {
		var $obj = $(this);
		showStatus('classmate_list_status', 'Updating classmate list ...');
		$.get('profile/ajax/classmates.cfm?r=' + Math.random(), {yp: $(this).attr('rel')}, function(data) {
			$obj.attr('rel', ($obj.attr('rel') == '0')?'1':'0');
			$obj.val((($obj.attr('rel') == '0')?'Hide':'Show') + ' ' + $obj.attr('title'));
			hideStatus('classmate_list_status');
			$('.classmate_list').html(data);
		});
	});
	
	$('#f_profile_comment').submit(function() {
		var d = getVal('txt_profile_comment');
		var $b = $(this).find('.btn');
		if (d.length > 0) {
			showStatus('profile_comment_status', 'Posting ...');
			$b.hide();
			
			$.post('profile/ajax/profile_comment.cfm', {r: getVal('member_id'), d:d}, function(data) {
				showStatus('profile_comment_status', data.ERROR, ((data.VALID)?'ok':'error'));
				if (data.VALID) {
					resetField('txt_profile_comment');
					$.get('profile/ajax/profile_comments.cfm', {id: getVal('member_id')}, function(data) {
						$('#profile_comments_block').html(data);
						initAssets();
					});
				}
				

				setTimeout(function() {
					$b.show();
					hideStatus('profile_comment_status');
				}, 4000);
				
			}, 'json' );
		}
		else {
			showAlert('Please enter a comment.');
		}
	});
	
	$('#f_announcement').submit(function() {
		var d = getVal('announcement');
		var id = getVal('announcement_media_id');
		var t = getVal('announcement_media_type');
		var url = getVal('announcement_media_url');
		var w = getVal('announcement_media_w');
		var h = getVal('announcement_media_h');
		var media_ids = '';
		$('#f_announcement .announcement_attachments .announcement_attachment_media').each(function() {
			media_ids = ListAppend(media_ids, $(this).attr('id').replace('member_media_', ''));
		});
		
		if (d.length > 0) {
			$('.announcement_submit').hide();
			showStatus('announcement_status', 'Posting ...');
			
			$.post('profile/ajax/activity_save.cfm', {a:8, r: getVal('member_id'), d:d, m_id:id, m_t:t, m_url:url, m_w:w, m_h:h, media_ids:media_ids}, function(data) {
				showStatus('announcement_status', data.ERROR, ((data.VALID)?'ok':'error'));
				if (data.VALID) {
					resetField('announcement');
					$('#recent_messages_block').removeClass('hide');
					if (data.HTM) {
						$('.announcement-feed').prepend(data.HTM);
						initAssets();
					}
					$('#announcement_media_type').val(0);
					$('#announcement_media_id').val('');
					$('#announcement_media_url').val('');
					$('#announcement_media_w').val('');
					$('#announcement_media_h').val('');
					$('#announcement_media_preview').html('');
					$('.announcement_attachment').hide();
					$('.announcement_attach').show();
					$('.announcement_attachments').html('');
					$('.announcement_attachments_block').hide();
					resetField('announcement_attachment_video_link');
					$('#announcement_attachment_video_link').hide();
					hideStatus('announcement_attachment_video_link_status');
				}
				setTimeout(function() {
					$('.announcement_submit').show();
					hideStatus('announcement_status');
				}, 4000);
			}, 'json' );
		}
		else {
			showAlert('Please enter a message for your Classmates');
		}
	});
	
	
	$('.dismiss').off('click').on('click', function() {
		// hide items right away.
		var $obj = $(this);
		$obj.closest('.notification').slideUp('500', function() {
			$obj.closest('.notification').remove();
			if ( $('.notification').length == 0) {
				$('.notifications_header').remove();
				$('.sideBox').first().addClass('firstSideBox');
			}
		});
		postJSON('profile/ajax/notification_dismiss.cfm', {type:$obj.attr('rel')}, 'dismiss_' + $obj.attr('rel') + '_status', function(data) {
		
		});
	});
	
	$('.dismiss_tip').off('click').on('click', function() {
		// hide items right away.
		var $obj = $(this);
		var $notification = $obj.closest('.msg-tip');
		var id = $notification.attr('id').replace('tip_', '')
		$notification.slideUp('500', function() {
			$notification.remove();
		});
		postJSON('profile/ajax/tip_dismiss.cfm', {id:id}, 'dismiss_tip_status', function(data) {
			//
		});
	});
	
	$('.non_classmate').off('click').on('click', function() {
		openProfileDialog('Report Non-Classmate', 'non_classmate.cfm?id=' + $('#member_id').val());
	});
	
	$('#invite_fb_all').off('click').on('click', function() {
		if ( $(this).is(':checked') ) {
			$('.invite_fb').prop('checked', true);
			$(this).parent().find('b').html('Deselect All Friends');
		}
		else {
			$('.invite_fb').prop('checked', false);			
			$(this).parent().find('b').html('Select All Friends');
		}
	});
	
	$('#invite_classmate_all').off('click').on('click', function() {
		if ( $(this).is(':checked') ) {
			$('.invite_classmate').prop('checked', true);
			$(this).parent().find('b').html('Deselect All Classmates');
		}
		else {
			$('.invite_classmate').prop('checked', false);			
			$(this).parent().find('b').html('Select All Classmates');
		}
	});
	
	$('#btn_invite_fb').off('click').on('click', function() {
		$(this).hide();
		$('.invite_fb_text').slideDown(500);
	});
	
	$('#btn_invite_fb_cancel').off('click').on('click', function() {
		$('.invite_fb_text').slideUp(500, function() { $('#btn_invite_fb').show(); } );
	})
	
	$('.more-text').each(function(){
		var $more = $(this);
		var id = $more.attr('id').replace('more_text_', '');
		var $holder = $('#long_text_' + id);
		var $inner = $holder.find('.long-text-holder-inner');
		var h1 = ((h1<175)?h2:175);
		$holder.css('height', h1 + 'px');
		var h2 = $inner.height().toString().replace('px', '');
		if (h1 < h2) {
			$more.closest('.more-text-holder').show();
		}
	});
	$('.more-text').off('click').on('click', function() {
		var $more = $(this);
		var id = $more.attr('id').replace('more_text_', '');
		var $holder = $('#long_text_' + id);
		var $inner = $holder.find('.long-text-holder-inner');
		var h1 = $holder.height().toString().replace('px', '');
		var h2 = $inner.height().toString().replace('px', '');
		h1 = ((h2<500)?h2:500);
		$more.closest('.more-text-holder').css('visibility', 'hidden');
		$holder.animate({height:h1 + 'px'}, 500, function() {
			if (h2 > 500) $holder.addClass('long-text-scroller');
		});
	});
	
	$('#vid').off('click').on('click', function() {	
		$(this).remove();
		playVideo();
	});
				
	$('.highlightBar>li>a, .btn_allfeatures').off('click').on('click', function() {
		$('.highlightBar>li>a').not($(this)).removeClass('selected');
		$('.highlightContent').not($('.' + $(this).attr('rel'))).hide();
		$(this).addClass('selected');
		$('.' + $(this).attr('rel')).show();		
		if ($(this).hasClass('btn_allfeatures')) {
			$('.allfeatures a').addClass('selected');
		}
	});
	
	/*
	$("ul.sf-menu").superfish({
		animation: {height: 'show'} // slide-down effect without fade-in
		,speed: 200
		,delay: 500 // 1.2 second delay on mouseout 
	});
	*/
	
	$('.follow, .notfollow').off('click').on('click', function() {
		//You are about to Follow Fred Quimbly. When Fred updates his Profile in the future you will be notified via the Facebook globe icon. You can change this setting any time from the Notify Me tab
	
		var $obj = $(this);
		var id = $obj.attr('rel').replace('follow_', '');
		var follow = ($(this).hasClass('follow'))?1:0;
		
		follow_id = id;
		follow_follow = follow;
		
		
		confirmAction(((follow_follow == 1)?('You are about to Follow ' + $obj.attr('title') + '. When ' + $obj.attr('title') + ' updates his Profile in the future you will be notified. You can change this setting any time from the Notify Me tab.'):('Stop Following ' + $obj.attr('title') + '?')), function(data) {			
			$obj.html('<i>Updating ...</i>');
			$.post('profile/ajax/follow.cfm', {id:follow_id, follow:follow_follow}, function(data) {
				//showAlert(data.ERROR);
				$('.follow_' + follow_id).each(function() {
					var t = $(this).attr('title');
					if ($(this).hasClass('notfollow')) {
						if (!$(this).hasClass('no_update')) {
							$(this).html('-follow ' + t + '-');
						}
						else {
							$(this).html('Follow ' + t);
						}
						$(this).removeClass('notfollow').addClass('follow');
						$('.following_header_' + follow_id).removeClass('following_header').addClass('notfollowing_header');
						$('.following_header_' + follow_id).html('Not Following');
					}
					else {
						if (!$(this).hasClass('no_update')) {
							$(this).html('-stop following ' + t + '-');
						}
						else {
							$(this).html('Following ' + t);
						}
						$(this).removeClass('follow').addClass('notfollow');
						$('.following_header_' + follow_id).removeClass('notfollowing_header').addClass('following_header');
						$('.following_header_' + follow_id).html('Following');
					}
				});
			}, 'json');
		}, function(data) {
			if ($obj.hasClass('notfollow')) {
				$obj.html('-stop following ' + t + '-');
			}
			else {
				$obj.html('-follow ' + t + '-');
			}		
		}, true);
	});
	
	
	$('#preloader').prepend('<img src="/assets/images/beadmin-tab-hfeat-off.jpg" width="1" height="1" /><img src="/assets/images/beadmin-tab-hfeat-off-2.jpg" width="1" height="1" /><img src="/assets/images/beadmin-tab-afeat-on.jpg" width="1" height="1" /><img src="/assets/images/beadmin-tab-afeat-off-2.jpg" width="1" height="1" /><img src="/assets/images/beadmin-tab-pricing-on.jpg" width="1" height="1" /><img src="/assets/images/beadmin-tab-pricing-off-2.jpg" width="1" height="1" /><img src="/assets/images/beadmin-buttons-on.jpg" width="1" height="1" /><img src="/assets/images/beadmin-viewallfeatures-on.jpg" width="1" height="1" />');
	
	/*
	var $classmates = $('.classmates_inner');
	$classmates.imagesLoaded(function(){
		$classmates.masonry({
			isAnimated: false,
			isFitWidth: true,
			itemSelector : '.classmate'
		});
	});
	*/
	
	/*
	$('#f_profile input, #f_profile select, #f_profile textarea').not('#message').off('change').on('change', function() {
		saveProfile($(this));
	});
	*/
	
	$('.save_profile').on('click', function() {
		var status = $(this).attr('id').replace('btn_', '') + '_status';
		saveProfile(status);
	});
	
	
	$('#btn_invite_fb_submit').on('click', function() {
		var s = getChecked('invite_fb');
		if (s.length > 0) {
			//showStatus('invite_fb_status', 'Sending request ...');
			sendRequest(s, 'Invite Your Friends', getVal('invite_fb_msg'));
		}
		else {
			showAlert('Please select the friends you want to invite. To invites all your friends listed, click "Select All Friends" checkbox.');
		}
	});
	
	
	$('#btn_invite_email_submit').on('click', function() {
		var e = getVal('invite_emails');
		var m = getVal('invite_email_message');
		if (e.length > 0) {
			showStatus('invite_email_status', 'Sending Message ...');
			postJSON('profile/ajax/invite_email.cfm', {e:e, m:m}, 'invite_email_status', function(data) {
				resetField('invite_emails');
			});
		}
		else {
			showAlert('Please enter the email addresses of the friends you want to invite.');
		}
	});
	
	
	$('#btn_invite_classmate_submit').on('click', function() {
		var c = getChecked('invite_classmate');
		var m = getVal('invite_email_message');
		if (c.length > 0) {
			showStatus('invite_classmate_status', 'Sending Message ...');
			postJSON('profile/ajax/invite_classmate.cfm', {c:c, m:m}, 'invite_classmate_status', function(data) {
			});
		}
		else {
			showStatus('invite_classmate_status', 'Please select classametes you want to invite.', 'error');
		}
	});
	
	
	$('#change_class').on('click', function() {
		//showAlert('This module is being updated. Please check back soon.');
		openProfileDialog('Visit Another Class', 'class_change.cfm', 600, 400);
	});
	
	
	// dupCheck
	
	$('#check_for_duplicate').each(function(){
		openProfileDialog('Is this you?','duplicate.cfm', 600);
	});
	
	
	// Welcome Message
	
	$('#welcome_message').each(function(){
		openProfileDialog('Welcome to Class Connection','welcome_message.cfm', 600);
	});
	
	
	// Invite Message
	
	$('#invite_message').each(function(){
		openProfileDialog('Welcome to Class Connection','invite_classmates.cfm', 600);
	});
	
	// Become Admin Message
	
	$('#become_admin_message').each(function(){
		openProfileDialog('Become Class Administrator','administrator.cfm', 600);
	});
	
	// profile permissions
	$('#profile_visibility_1').on('click', function() {
		$('#flag1').val('y');
	});
	$('#profile_visibility_2,#profile_visibility_3').on('click', function() {
		$('#flag1').val('');
	});
	
	$('.profile_media .imageHolder img').each(function() {
		var t = 'Profile Photo';
		if ($(this).closest('.rightMediaHolder').length) {
			t = $(this).closest('.rightMediaHolder').find('.caption').text();
		}
		if ($('#edit_mode').length || $(this).hasClass('admin_uploaded_yearbook_photo') || $(this).hasClass('no-image')) {
		}
		else {
			$(this).addClass('pointer');
			$(this).on('click', function() {
				openProfileDialogContent(t, '<div class="t_center"><img src="' + $(this).attr('rel') + '" class="img-responsive img-thumbnail" /></div>', 800);
			});
		}
	});
	
	initCropper();
	updateImageEditBtns();
	setSchoolNameSize();
	
	$('#more-announcements').on('click', function() {
		$obj = $(this);
		showStatus('announcements_status', 'Loading ...');
		announcements_page++;
		$.get('profile/ajax/announcements.cfm', {id:getVal('member_id'), p: announcements_page, l:last_announcement_id}, function(data) {
			$('.announcement-feed').append(data);
			if ( $('#activity-8-last').val() == 'yes') {
				$obj.hide();				
			}
			hideStatus('announcements_status');
		});
	});
	
	$('#more-photos').on('click', function() {
		$obj = $(this);
		$obj.hide();
		$loading = $obj.parent().append('<div class="status msg-loading loading-more-photos">Loading photos…</div>');
		page = photo_page++;
		$.get('profile/ajax/media.cfm', {t:1, page: page, member_id:getVal('member_id')}, function(data) {
			$('.photos-feed').append(data);
			$('.loading-more-photos').remove();
			if (data.length) {
				$obj.show();
				initAssets();
				preInitComments();
			}
		});
	});
	
	$('#more-videos').on('click', function() {
		$obj = $(this);
		$obj.hide();
		$loading = $obj.parent().append('<div class="status msg-loading loading-more-videos">Loading videos…</div>');
		page = video_page++;
		$.get('profile/ajax/media.cfm', {t:2, page: page, member_id:getVal('member_id')}, function(data) {
			$('.videos-feed').append(data);
			$('.loading-more-videos').remove();
			if (data.length) {
				$obj.show();
				initAssets();
				preInitComments();
			}
		});
	});
	
	if ( $('#activity-8-last').val() == 'yes') {
		$('#more-announcements').hide();				
	}
	
	if ( $('#activity-last').val() == 'yes') {
		$('#more-feed').hide();				
	}
	
	
	$('.dismissNextStep').on('click', function() {
		// hide items right away.
		var $obj = $(this).closest('.nextStep');
		$obj.slideUp('500', function() {
			$obj.remove();
			var i = 0;
			$('.nextStep').each(function() {
				$(this).find('h6').html((++i) + '.');
			});
			if ( $('.nextStep').length == 0) {
				// what to do if all done?
			}
		});
		postJSON('profile/ajax/nextstep_dismiss.cfm', {id:$obj.attr('id').replace('nextstep_', '')}, 'dismissed', function(data) {
		
		});
	});
	
	$('.nm_select').on('click', function() {
		var arr = $(this).attr('id').split('_');
		var nm_id = arr[1];
		var nm_val = arr[2];
		postJSON('profile/ajax/notifyme.cfm', {nm_id:nm_id, nm_val:nm_val}, 'nm_status', function(data) {
			// done
		});
	});
	
	$('.feedback').on('click', function() {
		openProfileDialog('Leave Feedback', 'feedback.cfm', 440);
	});
	
	$('.copy-link').on('click', function() {
		if (window.clipboardData) {
			window.clipboardData.setData('Text', $('#app_link').text());
		}
		else {
			window.prompt ('Copy link to clipboard: Ctrl+C, Enter', $('#app_link').text());
		}
	});
	
	$('.userName').hover( //hoverIntent(
		function(){ 
			if( true || !$('.account_menu').is(':animated') ){
				$('.account_menu').slideDown(300); 
			}
		}, 
		function() { 
			if( true || !$('.account_menu').is(':animated') ){
				$('.account_menu').slideUp(100); 
			}
		}
	);
	
	/**/
	var overAdminToolsTimeout;
	$('.admin_tools').on('mouseenter', function() {
			$('.admin_menu').show();
			clearTimeout(overAdminToolsTimeout);
	});
	$('.admin_tools').on('mouseleave', function() {			
		overAdminToolsTimeout = setTimeout(function() { $('.admin_menu').hide(); }, 500); 
	});
	
	$('#cvv2').click(function() {
		openProfileDialog('CVV2 Credit Card Security Codes', 'cvv2.cfm', 600);
	});
	
}
function initSlideshow() {
	//console.log('starting slideshow ...');
	setTimeout(function() {
	//console.log('now !');
	$('.flexslider').flexslider({
		animation: "slide",
		prevText: "",
		nextText: "",
		start: function(slider){
		},
		before: function(slide) {
			//$('#product_caption span').animate({opacity:0}, 0);
		},
		after: function(slider) {
    	//$('#product_caption span').html($('#product_slides li img').eq(slider.currentSlide + 1).attr('alt')).animate({opacity:1}, 500);
		}
	});}, 0);
}

function initSlideshow2() {
	$('#slideshow li .slide_img img').each(function() {
		var w1 = 400;
		var h1 = 500;
		var src = $(this).attr('src');
		var w = $(this).width();
		var h = $(this).height();
		var r = w/h;
		var r1 = w1/h1;
		if (r > r1) {
			h3 = w1/r;
			$(this).width(w1);
			$(this).height(h3);
			$(this).css('margin-top', Math.floor((h1-h3)/2) + 'px');
		}
		else {
			w3 = h1*r;
			$(this).width(w3);
			$(this).height(h1);
			$(this).css('margin-left', Math.floor((w1-w3)/2) + 'px');
		}
	});
	//console.log('starting slideshow ...');
	$('#pause').click(function() { $('#slides').cycle('pause'); return false; });
	$('#play').click(function() { $('#slides').cycle('resume'); return false; });
	$('#play').hide();
	
	$('#slideshow').hoverIntent(
		function() { $('#controls').fadeIn(); },
		function() { $('#controls').fadeOut(); }
	);
	
  //  	easing: 'easeInOutBack', 
	$('#slides').cycle({
			fx:     'scrollHorz',
			speed:   400,
			timeout: 3000,
			next:   '#next',
			prev:   '#prev',
			paused: function(cont, opts, byHover) {
				$('#play').show();
				$('#pause').hide();
			},
			resumed: function(cont, opts, byHover) {
				$('#play').hide();
				$('#pause').show();
			}
	});
	$('#slides').cycle('pause');
	preInitComments();
}


function setSchoolNameSize() {
	var w = $('#school_name_holder').width();
	var w1 = $('.school_name').width();
	var w2 = $('.class_year').width();
	var w3 = $('.change_class').width();
	var f1 = $('.school_name').css('font-size')
	if (!f1) return;
	f1 = f1.replace('px', '');
	var f2 = $('.class_year').css('font-size').replace('px', '');
	var f3 = $('.change_class').css('font-size').replace('px', '');
	
	while (((w1 * 1 + w2 * 1 + w3 * 1 + 60) > w) && (f2 > 6)) {
		$('.school_name').css('font-size', f1-- + 'px');
		$('.class_year').css('font-size', f2-- + 'px');
		f3 = (f2<f3)?f2:f3;
		$('.change_class').css('font-size', f3 + 'px');
		w1 = $('.school_name').width();
		w2 = $('.class_year').width();
		w3 = $('.change_class').width();
	}
}

function updateImageEditBtns() {
	$('.imageHolder').each(function() {
		var no_image1 = $(this).find('.img img').hasClass('no-image');
		var no_image2 = $(this).find('.img img').hasClass('admin_uploaded_yearbook_photo');
		var $btns = $(this).find('.image_edit_btns_editor');
		var $s = $(this).find('.image_btn_select');
		if (no_image1 || no_image2) {
			$btns.hide(); 
			$s.html('Select&hellip;');
		}
		else {
			$btns.show();
			$s.html('Change&hellip;');
		}
	});
	
	$('.album-holder').each(function() {
		if ($(this).find('.no-image').length) {
			$(this).find('.image_edit').hide();
		}
		else {			
			$(this).find('.image_edit').show();
		}
	});
}

function scrollToAnchor2($obj){
	return true;
	var aid = $obj.attr('href');
	var aTag = $('a[name="' + aid.replace('#', '') +'"]');
	$('html,body').animate({scrollTop: aTag.offset().top},'slow');
	return false;
}



function initCropper() {

	
	$('.image_btn_cropper').off('click').on('click', function() {
		var type = $(this).attr('rel');
		var $i = $('#image' + type);
		var src = $(this).closest('.imageHolder').find('.imageHolder_cropper img').attr('src');
		launchEditor('image' + type, $i.attr('src'), type)
	});
	
}

function getMessage(id, pid) {
	showStatus('message_body_status', 'Loading conversation ...');
	var $obj = $('#message_' + id);
	postJSON('profile/ajax/message.cfm', {id:id, pid:pid}, 'message_body_status', function(data) {
		if ($obj.hasClass('message_new')) {
			$obj.removeClass('message_new').addClass('message_read');
		}
		$('.message_body').html(data.RET);
		showMessage = true;
		initAssets();
	});
}

function getNotification(id) {
	showStatus('message_body_status', 'Loading notification ...');
	var $obj = $('#message_' + id);
	postJSON('profile/ajax/notification.cfm', {id:id}, 'message_body_status', function(data) {
		if ($obj.hasClass('message_new')) {
			$obj.removeClass('message_new').addClass('message_read');
		}
		$('.message_body').html(data.RET);
		showMessage = true;
		initAssets();
	});
}

function initProfileUploads() {
	$('.fileupload').each(function() {
		if ($(this).hasClass('media_gallery')) {
			var $o = $(this).closest('.media_block_top');
			var $s = $o.find('.fileupload-progress');
		}
		else {
			var $o = $(this).closest('.row-Recent-Activity');
			var $s = $o.find('.announcement-photo-status');
		}
		var $b = $o.find('.fileinput-button');
		$(this).fileupload({
			add: function(e, data) {
				var uploadErrors = [];
				var acceptFileTypes = /^image\/(gif|jpe?g|png)$/i;
				if(data.originalFiles[0]['type'].length && !acceptFileTypes.test(data.originalFiles[0]['type'])) {
						uploadErrors.push('Not an accepted file type. Only jpg, gif and png files can be uploaded.');
				}
				if(data.originalFiles[0]['size'].length && data.originalFiles[0]['size'] > 5000000) {
						uploadErrors.push('Filesize is too big');
				}
				if(uploadErrors.length > 0) {
						showAlert(uploadErrors.join("\n"));
				} else {
						data.submit();
				}
			},
			url: 'profile/ajax/upload.cfm',
			formData: {type: 1, is_gallery: getVal('is_gallery'), re_member_id:$('#re_member_id').val()},
			dataType: 'json',
			done: function (e, data) {
				//console.log('upload started by: ' + $o.attr('id'));
				setTimeout(function() {
					/*
					$('#progress .txt').hide();
					$('#progress .bar').slideUp(1000);
					*/
					$b.show();
					$s.hide();
				}, 2000);
				$.each(data.result.files, function (index, file) {
					//console.log('name: ' + file.name);
					//console.log('url: ' + file.url);
					if ($('#announcement_attachment').val() == 1) {
						$o.find('.comment-form .comment_attachment').show();
						$o.find('.announcement_attachments_block').show();
						$o.find('.announcement_attachments').append('<div id="member_media_' + file.MEMBER_MEDIA_ID + '" class="announcement_attachment_media"><div class="announcement_attachment_clip"></div><img id="photo_' + file.id + '" src="' + file.thumbnail + '" rel="' + file.large + '" /><a href="javascript:void(0)" class="announcement_attachment_edit btn btn-warning btn-sm"><i class="fa fa-pencil"></i></a><a href="javascript:void(0)" class="announcement_attachment_remove btn btn-danger btn-sm"><i class="fa fa-trash"></i></a></div>');
						initAssets();
					}
					else {
						getAlbums(file.id);
						galleryPreview(1);					
					}
					//$('<p/>').html('<img src="' + file.url + '" />').appendTo('#files');
				});
			},
			send: function (e, data) {
				$b.hide();
				$s.show().html('<div class="alert alert-warning" style="display:inline-block"><i class="fa fa-circle-o-notch fa-spin"></i> Uploading… <b></b></div>');
			},
			/*
			progress: function (e, data) {
				var progress = parseInt(data.loaded / data.total * 100, 10);
				$('#progress').show().html('Uploading ... <b>' + progress + '%</b>');
			},*/
			progressall: function (e, data) {
				var progress = parseInt(data.loaded / data.total * 100, 10);
				$b.hide();
				$s.find('.alert b').html(progress + '%');
			},
			fail: function (e, data) {
				$b.show();
				$s.show().html('<div class="alert alert-danger" style="display:inline-block"><i class="fa fa-exclamation-triangle"></i> Oops … something went wrong during file upload:<br /><small>' + data.errorThrown + '</small></div>');
			}
		});
 	});
	
	$('.video_upload').fileupload({
		url: 'profile/ajax/upload.cfm',
		dataType: 'json',
		formData: {type: 2, is_gallery: getVal('is_gallery'), title: getVal('video_title'), description: getVal('video_description') , re_member_id:$('#re_member_id').val()},
		done: function (e, data) {
			setTimeout(function() { $('#progress .bar').hide(1000); }, 2000);
			$.each(data.result.files, function (index, file) {
				$('#progress_vid').show().html('Processing video…');
				$.post('profile/ajax/upload_yt.cfm', {fn: file.filename, title: getVal('video_title'), description: getVal('video_description')}, function(data) {
					$('.btn-video-upload').show();
					$('#progress_vid').hide();
					if (data.VALID) {
						setTimeout( function() {
							$('.video_upload_block').slideUp(200);
							getVideos();
							galleryPreview(2);
						} , 2000);
					}
					else {
						showAlert(data.ERROR);
					}
				}, 'json');
				showAlert('Your video has been successfully uploaded to our servers and is now being sent to YouTube. This process can take anywhere from a few seconds to an hour depending on the size of the video. Your video will appears in your gallery once processing is complete.');
			});
		},
		progressall: function (e, data) {
			var progress = parseInt(data.loaded / data.total * 100, 10);
			/*
			$('#progress .bar').show().css(
				'width',
				progress + '%'
			);
			$('#progress .txt').html('Uploading ... <b>' + progress + '%</b>');
			*/
			$('#progress_vid').show().html('Uploading ... <b>' + progress + '%</b>');
			$('.btn-video-upload').hide();
		}
 	});
	
	
	
	/*
	$('#fileupload')
    .on('fileuploadadd', function (e, data) {console.log('fileuploadadd');})
    .on('fileuploadsubmit', function (e, data) {console.log('fileuploadsubmit');})
    .on('fileuploadsend', function (e, data) {console.log('fileuploadsend');})
    .on('fileuploaddone', function (e, data) {console.log('fileuploaddone');})
    .on('fileuploadfail', function (e, data) {console.log('fileuploadfail');})
    .on('fileuploadalways', function (e, data) {console.log('fileuploadalways');})
    .on('fileuploadprogress', function (e, data) { console.log('fileuploadprogress'); })
    .on('fileuploadprogressall', function (e, data) {console.log('fileuploadprogressall');})
    .on('fileuploadstart', function (e) {console.log('fileuploadstart');})
    .on('fileuploadstop', function (e) {console.log('fileuploadstop');})

    .on('fileuploadchange', function (e, data) {console.log('fileuploadchange');})
    .on('fileuploadpaste', function (e, data) {console.log('fileuploadpaste');})
    .on('fileuploaddrop', function (e, data) {console.log('fileuploaddrop');})
    .on('fileuploaddragover', function (e) {console.log('fileuploaddragover');})
    .on('fileuploadchunksend', function (e, data) {console.log('fileuploadchunksend');})
    .on('fileuploadchunkdone', function (e, data) {console.log('fileuploadchunkdone');})
    .on('fileuploadchunkfail', function (e, data) {console.log('fileuploadchunkfail');})
    .on('fileuploadchunkalways', function (e, data) {console.log('fileuploadchunkalways');});	
	*/
}


function getVideos() {
	$.get('profile/ajax/videos.cfm', {re_member_id:$('#re_member_id').val()}, function(data) {
		$('#video_list').html(data);
		resetField('video_title');
		resetField('video_description');
		$('.progress .txt').html('');
		initAssets();
	});
}

function getAlbums(file_id) {
	var type = ($('#fb_type'))?$('#fb_type').val():4;
	$.get('profile/ajax/media_fb_album.cfm', {t: type, re_member_id:$('#re_member_id').val()}, function(data) {
		$('.fb_albums').html(data);
		var id = getVal('folder_id');
		$.get('profile/dialog/media.cfm', {id:id, t:type, a_m:getVal('a_m'), c_m:getVal('c_m'), re_member_id:$('#re_member_id').val()}, function(data) {
			$('.fb_photos_inner').html(data);
			//.addClass('invisible')
			initAssets();
			if (typeof(file_id) != undefined && (getVal('a_m') == '1' || getVal('c_m') > 0 || type == '4' || type == '5' || type == '6' || type == '7')) {
				$('#photo_' + file_id + '>img').trigger('click');
			}
			/*setTimeout(function(){ $('.fb_photos_inner').masonry( 'reload').removeClass('invisible'); }, 1000);*/
		});
	});
}

function galleryPreview(type) {
	$.post('profile/ajax/media_gallery_preview.cfm', {t:type, re_member_id:$('#re_member_id').val()}, function(data) {
		if (type == 1) {
			$('#photos1').html(data.PHOTO_IMG);
			$('#photos2').html(data.PHOTO_COUNT);
		}
		else {
			$('#videos1').html(data.PHOTO_IMG);
			$('#videos2').html(data.PHOTO_COUNT);
		}
		updateImageEditBtns();
	}, 'json');
}

function saveProfile(status) {
	
	showStatus(status, 'Saving Changes ...');
	
	var params = $('#f_profile_2').serialize();
	$.post('profile/ajax/profile_save.cfm' + reMember('?'), params, function(data) {
		showStatus(status, data.ERROR, (data.VALID)?'ok':'error');
		if (data.VALID && data.LASTMOD) {
			$('.lastmod').html(data.LASTMOD);
			//$('.member_name').html($('#first_name').val() + ' ' + $('#last_name').val() + ' ' + $('#married_name').val());
			saveActivity(2);
		}
	}, 'json' );
}

function saveProfile1(status) {
	
	showStatus(status, 'Saving Changes ...');
	
	var params = {
			first_name: getVal('first_name')
		, last_name: getVal('last_name')
		, married_name: getVal('married_name')
		, story: getVal('story')
		, residing: getVal('residing')
		, children: getVal('children')
		, dobd: getVal('dobd')
		, dobm: getVal('dobm')
		, doby: getVal('doby')
		, spouse: getVal('spouse')
		, military: getVal('military')
		, phone: getVal('phone')
		, cell_phone: getVal('cell_phone')
		, email: getVal('email')
		, url: getVal('url')
		, bio: getVal('bio')
		, gender: getVal('gender')
		, misc: getVal('misc')
		, re_member_id:$('#re_member_id').val()
	};
	$.post('profile/ajax/profile_save.cfm', params, function(data) {
		if (data.VALID && data.LASTMOD) {
			$('.lastmod').html(data.LASTMOD);
			$('.member_name').html($('#first_name').val() + ' ' + $('#last_name').val() + ' ' + $('#married_name').val());	
			showStatus(status, data.ERROR, (data.VALID)?'ok':'error');
			saveActivity(2);
		}
	}, 'json' );
}

function saveActivity(a, r, m, d) {
	if (a == 7) return;
	if (!r) r = 0;
	if (!m) m = 0;
	if (!d) d = '';
	$.post('profile/ajax/activity_save.cfm', {a:a, r:r, m:m, d:d, re_member_id:$('#re_member_id').val()}, function(data) {
		if (data.VALID) {
			// confirm
		}
		if (a == 2 ) location.href='class_profile.cfm';
	}, 'json');
}

function showUploadProgress() {
	$('.upload_progress').slideDown();
}

function hideUploadProgress() {
	$('.upload_progress').slideUp();
}

function openProfileDialog(t, u, w, h) {
	var s = BootstrapDialog.SIZE_WIDE
	if (typeof w === 'undefined') {
	}
	else if (w < 500) {
		s = BootstrapDialog.SIZE_SMALL;
	}
	else if (w < 600) {
		s = BootstrapDialog.SIZE_NORMAL;
	}
	dialog = BootstrapDialog.show({
    size: s,
    title: t,
		message: $('<div><div class="alert alert-warning"><i class="fa fa-circle-o-notch fa-spin"></i> Please wait … Loading…</div>').load('profile/dialog/' + u, {}, function() { initAssets(); } ),
		closable:true,
		onshown: function(dialogRef) {
			initAssets();
		}
	});        	
}

function openProfileDialogContent(t, c, w, h) {
	dialog = BootstrapDialog.show({
    title: t,
		message: '<div class="pad-10">' + c + '</div>',
		closable:true,
		onshown: function(dialogRef) {
			initAssets();
		}	
	});
}

function reMember(symbol) {
	if (!symbol) symbol = '?';
 	return (($('#member_id').length)?( symbol + 're_member_id=' + $('#member_id').val()):'')
}

function getChecked(n) {
	var arr = [];
	$('input[name="' + n + '"]:checked').each(function() {
		arr.push($(this).val());
	});
	return arr.toString();
}


function postJSON(url, data, status, callback) {
	$.ajax({
		url: url,
		dataType: 'json',
		type: 'POST',
		data: data,
		success: function(data, textStatus, XMLHttpRequest) {
			if (data.ERROR.length > 0) {
				showStatus(status, data.ERROR, (data.VALID)?'ok':'error', true);
			}
			else {
				hideStatus(status);
			}
			if (data.VALID && callback) {
				callback(data);
			}
		},
		error: function(XMLHttpRequest, textStatus, errorThrown) {
			showStatus(status, 'Error while contacting server: ' + errorThrown, 'error');
		}
	});
}

function getVal(f) {
	var $obj = $('#' + f);
	if ($obj.hasClass('form-field')) {
		return ( ($obj.val() != $obj.attr('title'))?($obj.val()):('') );
	}
	else if ( $obj.attr('id') ) {
		return $obj.val();
	}
	else {
		return '0';
	}
}

function resetField(f) {
	var $obj = $('#' + f);
	$obj.val(($obj.attr('title'))?($obj.attr('title')):(''));
	if ($obj.hasClass('form-field')) {
		$obj.addClass('faded');
	}
}

function addLoading($obj, msg, css, absolute) {
	var css = 'warning';
	var fa = 'circle-o-notch fa-spin';
	
	switch (css) {
		case 'ok':
			css = 'success';
			fa = 'check';
		break;
		case 'error':
			css = 'danger';
			fa = 'exclamation-triangle';
		break;
	}
	var loading = ((absolute)?'<div class="loading-absolute">':'') + '<div class="alert alert-' + css + '" style="display:inline-block"><i class="fa fa-' + fa + '"></i> ' + ((msg)?msg:'Loading ...') + '</div>' + ((absolute)?'</div>':'');
	$obj.append(loading);
}

function removeLoading($obj) {
	$('#' + $obj.attr('id') + '_loading').remove();
}



var ajaxMemberSearch;

function initMemberSearch() {
	
	$('#member_name').off('keydown').on('keydown', function (e) {
		if ($(this).val() == $(this).attr('title')) {
			$(this).val('');
		}
	});
	
	$('#member_name').off('keyup').on('keyup', function (e) {
		
		showStatus('member_name_status', 'Searching ...');
		abortAjax(ajaxMemberSearch);
		
		$obj = $(this);
		ajaxMemberSearch = $.get('ajax/member_search.cfm', {member_name:encodeURI( $('#member_name').val() )}, function(data) {
			hideStatus('member_name_status');
			$('.member_list_scroller').html(data);
			if (data.length > 0) {
				$('.member_list').show();
			}
			else {
				$('.member_list').hide();
			}
			memberSearchInit();
		});
	});
	
	$('.change_school>a').off('click').on('click', function() {
		resetSchool();
	});
	
	$('.change_member>a').off('click').on('click', function() {
		resetMember();
	});
	

	$('#school_name').off('keyup').on('keyup', function (e) {
		
		abortAjax(ajaxSchoolSearch);

		$obj = $(this);
		var id = $obj.attr('id').replace('city_search_', '');
		ajaxSchoolSearch = $.get('profile/ajax/school_search.cfm', {school_name:$('#school_name').val(), change: 1, r:Math.random()}, function(data) {
			$('.school_list_scroller').html(data);
			if (data.length > 0) {
				$('.school_list').show();
			}
			else {
				$('.school_list').hide();
			}
			schoolSearchInit();
		});
	});
	
	resetSchool();
	
	$('.change_school>a').off('click').on('click', function() {
		resetSchool();
	});
	
	$('#btn_change_class').off('click').on('click', function() {
		if ( $('#school_id').val() > 0  && $('#class_year_id').val() > 0 ) {
			showStatus('change_class_status', 'Changing class ...');
			$.post('profile/ajax/change_class.cfm', {school_id: $('#school_id').val(), year_id: $('#class_year_id').val()}, function(data) {
				showStatus('change_class_status', data.ERROR, (data.VALID)?'ok':'error');
				if (data.VALID) {
					$('#btn_change_class').hide();
					location.href = '/home.cfm?visiting=1'
				}
			}, 'json');
		}
		else {
			showAlert('You must select school and year to proceed');
		}
	});
	
	$('#return_to_class, #return_to_class_nav').off('click').on('click', function() {
		$(this).html('<i>Returning to class ...</i>');
		$.post('profile/ajax/return_to_class.cfm', {}, function(data) {
			location.href = '/home.cfm';
		});
	});

}

function schoolSearchInit() {
	$('.school_list_scroller>a').attr('href', 'javascript:void(0)').off('click').on('click', function() {
		var id = $(this).attr('id').replace('school_', '');
		var name = $('#school_' + id + '>b').html();
		schoolSelect(id, name);
	});
}

function schoolSelect(id, name) {
	
	abortAjax(ajaxSchoolSearch);
	
	$('#school_id').val(id);
	$('#school_name').val(name);
	$('#school_name').removeClass('faded');
	$('.school_list').hide();
	$('.class_year_id').show();
	//$('.class_year_id').html('<div style="margin-left:70px" class="status msg-loading">Loading class years ...</div>');
	$.get('profile/ajax/year_search.cfm', {school_id: id}, function(data) {
		//$('.class_year_id').html(data);
		setTimeout(function() {
			$('.change_school').show();
			$('.btn-change-school').show();
		}, 200);
	});
}

function becomeAdmin() {
	postJSON('profile/ajax/become-administrator.cfm', {}, 'status_become_administrator', function(data) { location.href = data.REDIRECT; });
}

function resetMember() {
	$('#member_id').val(0);
	$('#member_name').val($('#member_name').attr('title')).addClass('faded');
	$('.change_member').hide();
}
function resetSchool() {
	$('#school_id').val(0);
	$('#school_name').val($('#school_name').attr('title')).addClass('faded');
	$('.change_school').hide();
	$('.btn-change-school').hide();
	$('.class_year_id').hide();
	$('#class_year_id').val('0');
}

function memberSearchInit() {
	$('.member_list_scroller>a').attr('href', 'javascript:void(0)').off('click').on('click', function() {
		memberSelect($(this).attr('id').replace('member_', ''));
	});
}

function memberSelect(id) {
	
	abortAjax(ajaxMemberSearch);
	
	$('#member_id').val(id);
	$('#member_name').val($('#member_' + id + '>b').html());
	$('#member_name').removeClass('faded');
	
	if ($('#page_id').val() == 'classmates') {		
		showStatus('member_name_status', 'Loading Profile...');
		location.href = 'profile/' + id;
	}
	setTimeout(function() {
		$('.member_list').hide();
		$('.change_member').show();
	}, 200);
}

function abortAjax(a) {
	if (a) {
		a.abort();
	}
}





// LIST FUNCTIONS

function ListLen(List,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	if (List == "") {
		return 0;
	} else {
		var CommaCount = 1;
		var newList = List;
		while (newList.indexOf(Delimiter) != -1) {
			CommaCount++;
			newList = newList.substring(newList.indexOf(Delimiter)+1);
		}
		return CommaCount;
	}
}

function ListGetAt(List,Index,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	if (Index > ListLen(List,Delimiter)) {
		return "";
	} else {
		var newList = List;
		// remove leading text
		for (var count = 1; count < Index; count++) {
			newList = newList.substring(newList.indexOf(Delimiter)+1);
		}
		// remove trailing text
		if (newList.indexOf(Delimiter) != -1) {
			newList = newList.substring(0,newList.indexOf(Delimiter));
		}
		return newList;
	}
}

function ListFirst(List,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	return ListGetAt(List,1,Delimiter);
}

function ListLast(List,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	return ListGetAt(List,ListLen(List,Delimiter),Delimiter);
}

function ListSetAt(List,Index,Element,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	if (Index <= ListLen(List,Delimiter)) {
		if (ListLen(List,Delimiter) < 1) {
			return -1;
		} else {
			List = Delimiter + List + Delimiter;
			var BeforeSet = List.substring(0,Find(List,Delimiter,Index)-1);
			var AfterSet = List.substr(Find(List,Delimiter,Index+1)-1);
			var newList = BeforeSet + Delimiter + Element + AfterSet;
			newList = newList.substring(1,newList.length-1);
			if (newList.substring(newList.length,1) == Delimiter) {
				newList = newList.substring(0,newList.length-1);
			}
			return newList;
		}
	} else {
		return -1;
	}
}

function ListInsertAt(List,Index,Element,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	if (List == "") return Element;
	if (Index > ListLen(List)) return ListAppend(List,Element,Delimiter);
	if (Index < 1) Index = 1;
	var newList = "";
	for (var i = 1; i < Index; i++) {
		newList = ListAppend(newList,ListGetAt(List,i,Delimiter),Delimiter);
	}
	newList = ListAppend(newList,Element,Delimiter);
	for (var i = Index; i <= ListLen(List); i++) {
		newList = ListAppend(newList,ListGetAt(List,i,Delimiter),Delimiter);
	}
	return newList;
}

function ListAppend(List,Element,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	if (ListLen(List,Delimiter) > 0) {
		List += Delimiter;
	}
	return List + Element;
}

function ListDeleteAt(List,Index,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	if (Index <= ListLen(List,Delimiter)) {
		if (ListLen(List,Delimiter) < 1) {
			return -1;
		} else {
			List = Delimiter + List + Delimiter;
			if (ListLen(List,Delimiter) == 3) {
				List += Delimiter;
			}
			var BeforeDelete = List.substring(0,Find(List,Delimiter,Index)-1);
			var AfterDelete = List.substr(Find(List,Delimiter,Index+1)-1);
			var newList = BeforeDelete + AfterDelete;
			newList = newList.substring(1,newList.length-1);
			if (newList.substring(newList.length,1) == Delimiter) {
				newList = newList.substring(0,newList.length-1);
			}
			return newList;
		}
	} else {
		return -1;
	}
}

function ListRest(List,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	return ListDeleteAt(List,1,Delimiter);
}

function ListFind(List,FindMe,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	try {
		for (var d = 1; d <= ListLen(List,Delimiter); d++) {
			if (ListGetAt(List,d,Delimiter).toString().toLowerCase() == FindMe.toString().toLowerCase()) {
				return d;
			}
		}
	}
	catch(err) {
		alert(err.description);
		alert(List);
		alert(FindMe);
	}
	return 0;
}







// STRING FUNCTIONS

function repeat_string(s,times) {
	var r = "";
	for (var i = 0; i < times; i++) {
		r += s;
	}
	return r;
}

function replaceAll(myString, oldChar, newChar, all) {
	if (typeof all == 'undefined') all = true;
	if (myString == "") return myString;
	var i = myString.indexOf(oldChar);
    while (i != -1) {
    	myString = myString.substring(0,i) + newChar + myString.substr(i + oldChar.length);
		if (!all) break;
		i = myString.indexOf(oldChar);
    }
    return myString;
}

function removeAll(myString, oldChar) {
	return replaceAll(myString, oldChar, "");
}

function Len(myString) {
	return myString.length;
}

function Left(myString, charCount) {
	// if (myString.length < charCount) return -1;
	return myString.substr(0,charCount);
}

function Right(myString, charCount) {
	// if (myString.length < charCount) return -1;
	return myString.substr(myString.length-charCount,myString.length);
}

function Trim(myString) {
	while (myString.charAt(0) == " " || escape(myString.charAt(0)) == "%0A" || escape(myString.charAt(0)) == "%0D" || escape(myString.charAt(0)) == "%09") {
		myString=myString.substring(1);
	}
	while (myString.charAt(myString.length-1) == " " || escape(myString.charAt(myString.length-1)) == "%0A" || escape(myString.charAt(myString.length-1)) == "%0D") {
		myString=myString.substring(0,myString.length-1);
	}
	return myString;
}

function getParameter(URL, Parameter) {
	if (URL.indexOf("?" + Parameter + "=") == -1 && URL.indexOf("&" + Parameter + "=") == -1) {
		return false;
	} else {
		var parameterPos = (URL.indexOf("?" + Parameter + "=") > URL.indexOf("&" + Parameter + "="))?URL.indexOf("?" + Parameter + "="):URL.indexOf("&" + Parameter + "=");
		parameterPos += 2 + Parameter.length;
		var parameterValue = URL.substr(parameterPos);
		if (parameterValue.indexOf("&") != -1) {

			parameterValue=parameterValue.substring(0,parameterValue.indexOf("&"));
		}
		return parameterValue;
	}
}

function isNumeric(thisString) {
	for (var d=0; d<thisString.length; d++) {
		if (thisString.charCodeAt(d) < 48 || thisString.charCodeAt(d) > 57) {
			if (thisString.charCodeAt(d) != 46 && thisString.charCodeAt(d) != 45) {
				return false;
			}
		}
	}
	if (charCount(thisString, ".") > 1 || charCount(thisString, "-") > 1 || (charCount(thisString, "-") == 1 && thisString.indexOf("-") != 0)) {
		return false;
	} else {
		return true;
	}
}

function containsNumeric(thisString) {
	var containsNumeric=false;
	var containsCharacter=false;
	for (var d=0; d<thisString.length; d++) {
		if (thisString.charCodeAt(d) > 47 && thisString.charCodeAt(d) < 58) {
			containsNumeric=true;
		}
	}
	return containsNumeric;
}

function NumberFormat(thisString,thisFormat) {
	thisString += "";
	thisFormat += "";
	if (!isNumeric(removeAlphas(thisString)) || !isNumeric(removeAlphas(thisFormat))) return -1;
	thisString = removeAlphas(thisString);
	// Remove leading 0
	if (Left(thisString, 2) == "0.") {
		thisString = Right(thisString,Len(thisString)-1);
	}
	// Add extras "9"s to the Format, as necessary
	for (var xxx=charCount(ListGetAt(thisFormat,1,"."),"9"); xxx < Len(ListGetAt(removeAll(removeAll(thisString,","),"-"),1,".")); xxx++) {
		thisFormat=ListSetAt(thisFormat,1,ListGetAt(thisFormat,1,".")+"9",".");
	}
	// Remove extra "9"s from the Format, as necessary
	format9Count = charCount(ListGetAt(thisFormat,1,"."),"9");
	for (var xxx=Len(ListGetAt(removeAll(removeAll(thisString,","),"-"),1,".")); xxx < format9Count; xxx++) {
		pos=Find(thisFormat,"9",charCount(ListGetAt(thisFormat,1,"."),"9"));
		thisFormat=ListSetAt(thisFormat,1,Left(ListGetAt(thisFormat,1,"."),pos-1)+Right(ListGetAt(thisFormat,1,"."),Len(ListGetAt(thisFormat,1,"."))-pos),".");
	}
	// Round if necessary
	if (ListLen(thisFormat,".") > 1 && charCount(ListGetAt(thisFormat,2,"."),"9") > 0) {
		thisString=Math.round(thisString*Math.pow(10,charCount(ListGetAt(thisFormat,2,"."),"9")))/Math.pow(10,charCount(ListGetAt(thisFormat,2,"."),"9"))+"";
	}
	// Remove leading from rounding
	if (Left(thisString, 2) == "0.") {
		thisString = Right(thisString,Len(thisString)-1)
	}
	if (Find(thisFormat,".",1) > 0 && Find(thisString,".",1) < 1) {
		// format has decimal but string does not
		thisString+=".";
		for (var www = 1; www <= Len(ListGetAt(thisFormat,ListLen(thisFormat,"."),".")); www++) {
			thisString+="0";
		}
	} else if (Find(thisFormat,".",1) < 1) {
		// format does not have a decimal
		thisString=Math.round(thisString)+"";
	} else if (Find(thisFormat,".",1) > 0 && Find(thisString,".",1) > 0) {
		// they both have a decimal
		for (var www=Len(ListGetAt(thisString,2,".")); www<charCount(ListGetAt(thisFormat,2,"."),"9"); www++) {
			thisString+="0";
		}
	}
	// Make negative if necessary
	if (Left(thisString,1) == "-") {
		thisFormat="-"+thisFormat;
	}
	// create Output String
	thisString = removeAll(removeAll(removeAll(thisString,","),"."),"-");	//so that we only have digits
	var outputString = "";
	while (thisFormat != "" && Find(thisFormat,"9",1)) {
		outputString+=Left(thisFormat,Find(thisFormat,"9",1)-1)+Left(thisString,1);
		thisFormat=Right(thisFormat,Len(thisFormat)-Find(thisFormat,"9",1));
		thisString=Right(thisString,Len(thisString)-1);
	}
	outputString+=thisFormat;
	return outputString;
}

function containsAlpha(thisString) {
	var containsAlpha=false;
	for (var d=0; d<thisString.length; d++) {
		if (thisString.charCodeAt(d) > 64 && thisString.charCodeAt(d) < 123) {
			containsAlpha=true;
		}
	}
	return containsAlpha;
}

function charCount(thisString, targetChar) {
	var count=0;
	for (var d=0; d<thisString.length; d++) {
		if (thisString.charAt(d) == targetChar) {
			count++
		}
	}
	return count;
}

function Find(thisString, targetSubString, instance) {
	// instance is the nth instance of thisString inside targetSubString
	if (instance == undefined) instance = 1;
	var newString = thisString;
	var charCount = 0;
	while (instance > 0) {
		if (newString.indexOf(targetSubString) != -1) {
			charCount += newString.indexOf(targetSubString) + 1;
			newString = newString.substr(newString.indexOf(targetSubString)+1);
			instance--;
		} else {
			return -1;
		}
	}
	return charCount;
}

function Reverse(myString) {
	var newString="";
	for (var d = 0; d<myString.length; d++) {
		newString=myString.substr(d,1)+newString;
	}
	return newString;
}

function URLEncodedFormat(myString) {
	var newString = myString;
	newString = replaceAll(newString, "%", "%25");
	newString = replaceAll(newString, " ", "%20");
	newString = replaceAll(newString, "&", "%26");
	newString = replaceAll(newString, "?", "%3F");
	newString = replaceAll(newString, ".", "%2E");
	newString = replaceAll(newString, "!", "%21");
	newString = replaceAll(newString, "#", "%23");
	newString = replaceAll(newString, "@", "%40");
	newString = replaceAll(newString, "$", "%24");
	newString = replaceAll(newString, "+", "%2B");
	newString = replaceAll(newString, "[", "%5B");
	newString = replaceAll(newString, "]", "%5D");
	newString = replaceAll(newString, "{", "%7B");
	newString = replaceAll(newString, "}", "%7D");
	newString = replaceAll(newString, ";", "%3B");
	newString = replaceAll(newString, ":", "%3A");
	newString = replaceAll(newString, "'", "%27");
	newString = replaceAll(newString, ",", "%2C");
	newString = replaceAll(newString, "<", "%3C");
	newString = replaceAll(newString, ">", "%3E");
	newString = replaceAll(newString, "/", "%2F");
	newString = replaceAll(newString, '"', '%22');
	return newString;
}

function removeAlphas(tempNumber) {
	var tempLH="";
	var tempRH=tempNumber;
	for (var a=0; a<tempNumber.length; a++) {
		if (isNumeric(Left(tempRH,1)))
			tempLH+=Left(tempRH,1);
		if (tempRH.length > 1)
			tempRH=Right(tempRH, tempRH.length-1);
	}
	return tempLH;
}

function percentFormat(thisNumber) {
	var tempNumber = removeAlphas(thisNumber);
	if (Trim(tempNumber) == "")
		return 0;
	// if (tempNumber > 100)
	//	return 100;
	// else
		return tempNumber;
}

function MoneyFormat(thisNumber,commas) {
	if (commas == undefined) commas = false;
	var tempNumber = thisNumber.toString();
	if (thisNumber != "var") {
		tempNumber = tempNumber.replace(/[^\d.]/g,'');
		if (charCount(tempNumber,".") > 1) {
			// if there is a 2nd ".", remove it and everything past it.
			tempNumber = Left(tempNumber,Find(tempNumber,".",2)-1);
		}
		while (Left(tempNumber,1) == "0") {
			tempNumber = Right(tempNumber,Len(tempNumber)-1);
		}
		if (Left(tempNumber,1) == ".") {
			tempNumber = "0" + tempNumber;
		}
		if (Trim(tempNumber) == "") {
			return "0.00";
		}
		var InDecPlaces = 0;
		if (Find(tempNumber, ".", 1) == -1) {
			// check for no decimal
			tempNumber+=".";
		} else {
			// check for too many digits
			InDecPlaces = Len(tempNumber)-Find(tempNumber, ".", 1);
			if (InDecPlaces > 2) {
				tempNumber = Left(tempNumber, Find(tempNumber, ".", 1)+3);
				if (parseInt(Right(tempNumber,1)) > 4) {
					tempNumber *= 1;
					tempNumber += parseFloat(1*.01);
				}
				tempNumber = tempNumber + "";
				tempNumber = Left(tempNumber, Find(tempNumber, ".", 1)+2);
			}	
		}
		InDecPlaces = Len(tempNumber) - Find(tempNumber, ".", 1);
		for (var d = 0; d < (2-InDecPlaces); d++) {
			tempNumber += "0";
		}
		if (Len(tempNumber) > 6) {
			tempRH=Right(tempNumber, 3);
			tempLH=Left(tempNumber, Len(tempNumber)-3);
			while (Len(replaceAll(tempLH,"-","")) > 3) {
				tempRH=Right(tempLH, 3) + tempRH;
				if (Len(replaceAll(tempLH,"-","")) > 3) {
					tempRH="," + tempRH;
					tempLH=Left(tempLH, Len(tempLH)-3);
				} else {
					tempLH="";
				}
			}
			tempNumber=tempLH+tempRH;	
		}
	}
	if (!commas) tempNumber = tempNumber.replace(/,/g,'');
	return tempNumber;
}






// DATE FUNCTIONS

function now_() { 
	return ( new Date().getTime() );
}

function y2k(number) { 
	return (number < 1000) ? number + 1900 : number;
}

function changeDays(MonthObject,DayObject) {
	var selectedValue = DayObject.selectedIndex;
	var tempDate = new Date(2000,MonthObject.selectedIndex-(MonthObject.length-12),27);
	var DaysInMonth = 27;
	while (tempDate.getMonth() == MonthObject.selectedIndex-(MonthObject.length-12)) {
		DaysInMonth++;
		tempDate=new Date(2000,MonthObject.selectedIndex-(MonthObject.length-12),DaysInMonth+1);
	}
	if (DaysInMonth==28) {
		DaysInMonth=29;
	}
	if (selectedValue > DaysInMonth) {
		selectedValue = DaysInMonth;
	}
	for (var i=31; i > 1; i--) {
		DayObject.options[i]=null;
	}
	for (var i=1; i < 31; i++) {
		DayObject.options[i]=null;
	}
	var tempOption=new Option();
	for (var i = 1 + (1-(MonthObject.length-12)); i <= DaysInMonth; i++) {
		tempOption=new Option(i,i);
		eval("DayObject.options[i-(1-(MonthObject.length-12))]=tempOption")
		if (i == selectedValue) {
			DayObject.options[i-(1-(MonthObject.length-12))].selected = true;
		}
	}
}

function changeDays2(MonthObject,DayObject,YearObject) {
	var selectedValue = DayObject.selectedIndex;
	var tempDate = new Date(YearObject[YearObject.selectedIndex].value,MonthObject.selectedIndex-(MonthObject.length-12),27);
	var DaysInMonth = 27;
	while(tempDate.getMonth() == MonthObject.selectedIndex-(MonthObject.length-12)) {
		DaysInMonth++;
		tempDate=new Date(YearObject[YearObject.selectedIndex].value,MonthObject.selectedIndex-(MonthObject.length-12),DaysInMonth+1);
	}
	// if (DaysInMonth==28)
	//	DaysInMonth=29;
	if (selectedValue > DaysInMonth)
		selectedValue = DaysInMonth;
	for (var i=31; i > 1; i--) {
		DayObject.options[i]=null;
	}
	for (var i=1; i < 31; i++) {
		DayObject.options[i]=null;
	}
	var tempOption=new Option();
	for (var i=1+(1-(MonthObject.length-12)); i <= DaysInMonth; i++) {
		tempOption=new Option(i,i);
		eval("DayObject.options[i-(1-(MonthObject.length-12))]=tempOption")
		if (i==selectedValue) {
			DayObject.options[i-(1-(MonthObject.length-12))].selected=true
		}
	}
}

function startToday(Form,WhichDate) {
	var thisMonth=new Date().getMonth()+1;
	var thisDay=new Date().getDate();
	var thisYear=new Date().getFullYear();
	for (var i=1; i <= 12; i++) {
		if (i==thisMonth)
			eval("Form."+WhichDate+"Month.options[i].selected=true")
		}
	for (var i=1; i < 32; i++) {
		if (i==thisDay)
			eval("Form."+WhichDate+"Day.options[i].selected=true")
		}
    eval("Form."+WhichDate+"Year.value=thisYear")
	// Form.OnStudyYear.value=thisYear;
}

function startToday2(frmObj) {
	var thisMonth=new Date().getMonth()+1;
	var thisDay=new Date().getDate();
	var thisYear=new Date().getYear();	 	
	frmObj.value=thisMonth+"/"+thisDay+"/"+thisYear;
}

function isSQLDate (month,day,year) {
	if (year < 1753 || month > 12) {
		return false;
	} else {
		return isDate(month,day,year);
	}
}

function isDate (month,day,year) {
	// checks if date passed is valid
	// will accept dates in following format:
	// isDate(dd,mm,ccyy), or
	// isDate(dd,mm) - which defaults to the current year, or
	// isDate(dd) - which defaults to the current month and year.
	// Note, if passed the month must be between 1 and 12, and the
	// year in ccyy format.
	var today = new Date();
	year = ((!year) ? y2k(today.getYear()):year);
	month = ((!month) ? today.getMonth():month-1);
	if (!day) return false
	var test = new Date(year,month,day);
	return ( y2k(test.getYear()) == year && month == test.getMonth() && day == test.getDate() );
}

function validateDate(month,day,year) {
	if (year.length != 4 || month.length == 0 || year.length == 0 || day.length == 0 || month > 12)
		return false;
	// Check for valid date and that it's SQL compatible (1/1/1753 or greater)
	return isSQLDate(month,day,year);
}

function validateStringDate(stringDate) {
	var stringYear=Right(stringDate, 4);
	var stringMonth=Left(stringDate,Find(stringDate,"/",1)-1);
	var stringDay=stringDate.substr(Find(stringDate,"/",1),Find(stringDate,"/",2)-Find(stringDate,"/",1)-1);
	if (stringMonth > 12)
		return false;
	else
		return validateDate(stringMonth,stringDay,stringYear);
}

function dateCompare(firstDate, secondDate) {
	// Returns -1 if firstDate is smaller than secondDate, 0 if they are equal, 1 if firstDate is greater than secondDate
	var firstYear = Right(firstDate, 4);
	var firstMonth = Left(firstDate,Find(firstDate,"/",1)-1)-1;
	var firstDay = firstDate.substr(Find(firstDate,"/",1),Find(firstDate,"/",2)-Find(firstDate,"/",1)-1);
	var secondYear = Right(secondDate, 4);
	var secondMonth = Left(secondDate,Find(secondDate,"/",1)-1)-1;
	var secondDay = secondDate.substr(Find(secondDate,"/",1),Find(secondDate,"/",2)-Find(secondDate,"/",1)-1);
	Date1 = new Date(firstYear,firstMonth,firstDay);
	Date2 = new Date(secondYear,secondMonth,secondDay);
	if (Date1.getYear() < Date2.getYear()) {
		return -1;
	} else if (Date1.getYear() > Date2.getYear()) {
		return 1;
	} else {
		if (Date1.getMonth() < Date2.getMonth()) {
			return -1;
		} else if (Date1.getMonth() > Date2.getMonth()) {
			return 1;
		} else {
			if (Date1.getDate() < Date2.getDate()) {
				return -1;
			} else if (Date1.getDate() > Date2.getDate()) {
				return 1;
			} else {
				return 0;
			}
		}
	}
}

function DaysInMonth(thisMonth, thisYear) {
	var DayCount=28;
	var tempDate=new Date(thisYear,thisMonth-1,DayCount);
	while(tempDate.getMonth() == thisMonth-1) {
		DayCount++;
		tempDate=new Date(thisYear,thisMonth-1,DayCount);
	}
	return DayCount-1;
}

function blankDate(Form,WhichDate) {
    eval("Form."+WhichDate+"Month.options[0].selected=true");
    eval("Form."+WhichDate+"Day.options[0].selected=true");
    eval("Form."+WhichDate+"Year.value=''")
}








var errString,errCount,focusObj;
function dentedBadge() {
	errString = "";
	errCount = 1;
	focusObj = 0;
}

function badPoFo() {
	alert_wrap("The following errors occurred:\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n" + errString);
	if (typeof(focusObj) == "object" && focusObj) {
		setTimeout(function() {
			focusObj.focus();
			focusObj.focus(); // gotta do it twice
		},200);
	}
}

function alert_wrap(s){
	showAlert(s);
}






// LIST FUNCTIONS

function ListLen(List,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	if (List == "") {
		return 0;
	} else {
		var CommaCount = 1;
		var newList = List;
		while (newList.indexOf(Delimiter) != -1) {
			CommaCount++;
			newList = newList.substring(newList.indexOf(Delimiter)+1);
		}
		return CommaCount;
	}
}

function ListGetAt(List,Index,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	if (Index > ListLen(List,Delimiter)) {
		return "";
	} else {
		var newList = List;
		// remove leading text
		for (var count = 1; count < Index; count++) {
			newList = newList.substring(newList.indexOf(Delimiter)+1);
		}
		// remove trailing text
		if (newList.indexOf(Delimiter) != -1) {
			newList = newList.substring(0,newList.indexOf(Delimiter));
		}
		return newList;
	}
}

function ListFirst(List,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	return ListGetAt(List,1,Delimiter);
}

function ListLast(List,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	return ListGetAt(List,ListLen(List,Delimiter),Delimiter);
}

function ListSetAt(List,Index,Element,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	if (Index <= ListLen(List,Delimiter)) {
		if (ListLen(List,Delimiter) < 1) {
			return -1;
		} else {
			List = Delimiter + List + Delimiter;
			var BeforeSet = List.substring(0,Find(List,Delimiter,Index)-1);
			var AfterSet = List.substr(Find(List,Delimiter,Index+1)-1);
			var newList = BeforeSet + Delimiter + Element + AfterSet;
			newList = newList.substring(1,newList.length-1);
			if (newList.substring(newList.length,1) == Delimiter) {
				newList = newList.substring(0,newList.length-1);
			}
			return newList;
		}
	} else {
		return -1;
	}
}

function ListInsertAt(List,Index,Element,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	if (List == "") return Element;
	if (Index > ListLen(List)) return ListAppend(List,Element,Delimiter);
	if (Index < 1) Index = 1;
	var newList = "";
	for (var i = 1; i < Index; i++) {
		newList = ListAppend(newList,ListGetAt(List,i,Delimiter),Delimiter);
	}
	newList = ListAppend(newList,Element,Delimiter);
	for (var i = Index; i <= ListLen(List); i++) {
		newList = ListAppend(newList,ListGetAt(List,i,Delimiter),Delimiter);
	}
	return newList;
}

function ListAppend(List,Element,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	if (ListLen(List,Delimiter) > 0) {
		List += Delimiter;
	}
	return List + Element;
}

function ListDeleteAt(List,Index,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	if (Index <= ListLen(List,Delimiter)) {
		if (ListLen(List,Delimiter) < 1) {
			return -1;
		} else {
			List = Delimiter + List + Delimiter;
			if (ListLen(List,Delimiter) == 3) {
				List += Delimiter;
			}
			var BeforeDelete = List.substring(0,Find(List,Delimiter,Index)-1);
			var AfterDelete = List.substr(Find(List,Delimiter,Index+1)-1);
			var newList = BeforeDelete + AfterDelete;
			newList = newList.substring(1,newList.length-1);
			if (newList.substring(newList.length,1) == Delimiter) {
				newList = newList.substring(0,newList.length-1);
			}
			return newList;
		}
	} else {
		return -1;
	}
}

function ListRest(List,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	return ListDeleteAt(List,1,Delimiter);
}

function ListFind(List,FindMe,Delimiter) {
	if (typeof Delimiter == 'undefined') Delimiter = ',';
	try {
		for (var d = 1; d <= ListLen(List,Delimiter); d++) {
			if (ListGetAt(List,d,Delimiter).toString().toLowerCase() == FindMe.toString().toLowerCase()) {
				return d;
			}
		}
	}
	catch(err) {
		alert(err.description);
		alert(List);
		alert(FindMe);
	}
	return 0;
}



// DATE FUNCTIONS

function now_() { 
	return ( new Date().getTime() );
}

function y2k(number) { 
	return (number < 1000) ? number + 1900 : number;
}

function changeDays(MonthObject,DayObject) {
	var selectedValue = DayObject.selectedIndex;
	var tempDate = new Date(2000,MonthObject.selectedIndex-(MonthObject.length-12),27);
	var DaysInMonth = 27;
	while (tempDate.getMonth() == MonthObject.selectedIndex-(MonthObject.length-12)) {
		DaysInMonth++;
		tempDate=new Date(2000,MonthObject.selectedIndex-(MonthObject.length-12),DaysInMonth+1);
	}
	if (DaysInMonth==28) {
		DaysInMonth=29;
	}
	if (selectedValue > DaysInMonth) {
		selectedValue = DaysInMonth;
	}
	for (var i=31; i > 1; i--) {
		DayObject.options[i]=null;
	}
	for (var i=1; i < 31; i++) {
		DayObject.options[i]=null;
	}
	var tempOption=new Option();
	for (var i = 1 + (1-(MonthObject.length-12)); i <= DaysInMonth; i++) {
		tempOption=new Option(i,i);
		eval("DayObject.options[i-(1-(MonthObject.length-12))]=tempOption")
		if (i == selectedValue) {
			DayObject.options[i-(1-(MonthObject.length-12))].selected = true;
		}
	}
}

function changeDays2(MonthObject,DayObject,YearObject) {
	var selectedValue = DayObject.selectedIndex;
	var tempDate = new Date(YearObject[YearObject.selectedIndex].value,MonthObject.selectedIndex-(MonthObject.length-12),27);
	var DaysInMonth = 27;
	while(tempDate.getMonth() == MonthObject.selectedIndex-(MonthObject.length-12)) {
		DaysInMonth++;
		tempDate=new Date(YearObject[YearObject.selectedIndex].value,MonthObject.selectedIndex-(MonthObject.length-12),DaysInMonth+1);
	}
	// if (DaysInMonth==28)
	//	DaysInMonth=29;
	if (selectedValue > DaysInMonth)
		selectedValue = DaysInMonth;
	for (var i=31; i > 1; i--) {
		DayObject.options[i]=null;
	}
	for (var i=1; i < 31; i++) {
		DayObject.options[i]=null;
	}
	var tempOption=new Option();
	for (var i=1+(1-(MonthObject.length-12)); i <= DaysInMonth; i++) {
		tempOption=new Option(i,i);
		eval("DayObject.options[i-(1-(MonthObject.length-12))]=tempOption")
		if (i==selectedValue) {
			DayObject.options[i-(1-(MonthObject.length-12))].selected=true
		}
	}
}

function startToday(Form,WhichDate) {
	var thisMonth=new Date().getMonth()+1;
	var thisDay=new Date().getDate();
	var thisYear=new Date().getFullYear();
	for (var i=1; i <= 12; i++) {
		if (i==thisMonth)
			eval("Form."+WhichDate+"Month.options[i].selected=true")
		}
	for (var i=1; i < 32; i++) {
		if (i==thisDay)
			eval("Form."+WhichDate+"Day.options[i].selected=true")
		}
    eval("Form."+WhichDate+"Year.value=thisYear")
	// Form.OnStudyYear.value=thisYear;
}

function startToday2(frmObj) {
	var thisMonth=new Date().getMonth()+1;
	var thisDay=new Date().getDate();
	var thisYear=new Date().getYear();	 	
	frmObj.value=thisMonth+"/"+thisDay+"/"+thisYear;
}

function isSQLDate (month,day,year) {
	if (year < 1753 || month > 12) {
		return false;
	} else {
		return isDate(month,day,year);
	}
}

function isDate (month,day,year) {
	// checks if date passed is valid
	// will accept dates in following format:
	// isDate(dd,mm,ccyy), or
	// isDate(dd,mm) - which defaults to the current year, or
	// isDate(dd) - which defaults to the current month and year.
	// Note, if passed the month must be between 1 and 12, and the
	// year in ccyy format.

	var today = new Date();
	year = ((!year) ? y2k(today.getYear()):year);
	month = ((!month) ? today.getMonth():month-1);
	if (!day) return false
	var test = new Date(year,month,day);
	return ( y2k(test.getYear()) == year && month == test.getMonth() && day == test.getDate() );
}

function validateDate(month,day,year) {
	if (year.length != 4 || month.length == 0 || year.length == 0 || day.length == 0 || month > 12)
		return false;
	// Check for valid date and that it's SQL compatible (1/1/1753 or greater)
	return isSQLDate(month,day,year);
}

function validateStringDate(stringDate) {
	var stringYear=Right(stringDate, 4);
	var stringMonth=Left(stringDate,Find(stringDate,"/",1)-1);
	var stringDay=stringDate.substr(Find(stringDate,"/",1),Find(stringDate,"/",2)-Find(stringDate,"/",1)-1);
	if (stringMonth > 12)
		return false;
	else
		return validateDate(stringMonth,stringDay,stringYear);
}

function dateCompare(firstDate, secondDate) {
	// Returns -1 if firstDate is smaller than secondDate, 0 if they are equal, 1 if firstDate is greater than secondDate
	var firstYear = Right(firstDate, 4);
	var firstMonth = Left(firstDate,Find(firstDate,"/",1)-1)-1;
	var firstDay = firstDate.substr(Find(firstDate,"/",1),Find(firstDate,"/",2)-Find(firstDate,"/",1)-1);
	var secondYear = Right(secondDate, 4);
	var secondMonth = Left(secondDate,Find(secondDate,"/",1)-1)-1;
	var secondDay = secondDate.substr(Find(secondDate,"/",1),Find(secondDate,"/",2)-Find(secondDate,"/",1)-1);
	Date1 = new Date(firstYear,firstMonth,firstDay);
	Date2 = new Date(secondYear,secondMonth,secondDay);
	if (Date1.getYear() < Date2.getYear()) {
		return -1;
	} else if (Date1.getYear() > Date2.getYear()) {
		return 1;
	} else {
		if (Date1.getMonth() < Date2.getMonth()) {
			return -1;
		} else if (Date1.getMonth() > Date2.getMonth()) {
			return 1;
		} else {
			if (Date1.getDate() < Date2.getDate()) {
				return -1;
			} else if (Date1.getDate() > Date2.getDate()) {
				return 1;
			} else {
				return 0;
			}
		}
	}
}

function DaysInMonth(thisMonth, thisYear) {
	var DayCount=28;
	var tempDate=new Date(thisYear,thisMonth-1,DayCount);
	while(tempDate.getMonth() == thisMonth-1) {
		DayCount++;
		tempDate=new Date(thisYear,thisMonth-1,DayCount);
	}
	return DayCount-1;
}

function blankDate(Form,WhichDate) {
    eval("Form."+WhichDate+"Month.options[0].selected=true");
    eval("Form."+WhichDate+"Day.options[0].selected=true");
    eval("Form."+WhichDate+"Year.value=''")
}



// form fun

function mikeForm(form,IDs,fields,struct,first,prefix) {
	if (typeof IDs != "object") IDs = listToArray(IDs);
	if (typeof fields != "object") fields = listToArray(fields);
	if (prefix == undefined) prefix = "";
	for (var i = 0; i < IDs.length; i++) {
		var ID = IDs[i];
		if (first && !struct[ID]) struct[ID] = {};
		for (var j = 0; j < fields.length; j++) {
			var field = fields[j];
			var o = form[field+"_"+prefix+ID];
			if (o && !(!first && !struct[ID][field])) {
				var o_type = (o.type) ? o.type : o[0].type;
				if (o_type == "select-one") {
					if (first) struct[ID][field] = getSelect(o); else setSelect(o,struct[ID][field]);
				} else if (ListFind("hidden,text,textarea",o_type)) {
					if (first) struct[ID][field] = o.value; else o.value = struct[ID][field].toString();
				} else {
					if (first) struct[ID][field] = getRadioCheck(o); else setRadioCheck(o,struct[ID][field]);
				}
			}
		}
	}
}

function bi(obj) {
	return document.getElementById(obj);
}

function arrayUpDown(array,cur,dir,lookup) {
	if (!cur && lookup) cur = arrayPos(array,cur);
	if (cur < 0 || cur >= array.length) return;
	var me = array[cur];
	array.splice(cur,1);
	if (dir == -1) {
		if (cur == 0) {
			array.push(me);
		} else {
			array.splice(cur-1,0,me);
		}
	} else {
		if (cur == array.length) {
			array.splice(0,0,me);
		} else {
			if (cur == array.length - 1) {
				array.push(me);
			} else {
				array.splice(cur+1,0,me);
			}
		}
	}
}

function arraySplice(array,cur,niu,lookup) {
	if (lookup != undefined) cur = arrayPos(array,cur);
	if (niu < 0 || niu >= array.length) return;
	array.splice(niu,0,array[cur]);
	array.splice(cur+(niu<cur)?1:0,1);
}

function getRadioCheck(obj) {
	var ret = [];
	if (obj) {
		var len = obj.length;
		if (len == undefined) {
			if (obj.checked) {
				ret.push(obj.value);
			}
		} else {
			for (var i = 0; i < len; i++) {
				if (obj[i].checked) {
					ret.push(obj[i].value);
				}
			}
		}
	}
	return ret;
}

function setRadioCheck(obj,newValue,onoff) {
	if (typeof onoff == 'undefined') onoff = true;
	if (obj) {
		if (typeof newValue != "object") newValue = listToArray(newValue);
		var len = obj.length;
		for (var a = 0; a < newValue.length; a++) {
			if (len == undefined) {
				obj.checked = (obj.value == newValue[a].toString());
			} else {
				for (var i = 0; i < len; i++) {
					if (obj[i].value == newValue[a].toString()) {
						obj[i].checked = onoff;
						break;
					}
				}
			}
		}
	}
}

function getSelect(obj) {
	return obj[obj.selectedIndex].value;
}

function setSelect(obj,newValue) {
	for (var i = 0; i < obj.length; i++) {
		if (obj[i].value.toString().toLowerCase() == newValue.toString().toLowerCase()) {
			obj.selectedIndex = i;
			break;
		}
	}
}

function checkbox_checkAll(formObj,truefalse) {
 	if (formObj) {
		if (!formObj.length) {
			formObj.checked = truefalse;
		} else {
			for (var i = 0; i < formObj.length; i++)
				formObj[i].checked = truefalse;
		}
	}
}

function checkbox_countChecks(formObj) {
 	if (formObj) {
		if (!formObj.length) {
			return (formObj.checked) ? 1 : 0;
		} else {
		 	var checkCount = 0;
			for (var i = 0; i < formObj.length; i++) {
				if (formObj[i].checked) {
					checkCount++;
				}
			}
			return checkCount;
		}
	} else {
		return -1;
	}
}

function arrayPos(array,findMe) {
	for (var i = 0; i < array.length; i++) {
		if (array[i].toString().toLowerCase() == findMe.toString().toLowerCase()) {
			return i;
		}
	}
	return -1;
}

function listToArray(list) {
	var array = [];
	list = list.toString();
	for (var i = 1; i <= ListLen(list); i++) {
		array.push(ListGetAt(list,i));
	}
	return array;
}

function validateCreditCard(cardNumber,cardType) {
	// if (cardNumber.charAt(0) == '*') return true;
	var isValid = false;
	isValid = !/[^\d -]/.test(cardNumber);
	if (isValid) {
		var cardNumbersOnly = cardNumber.replace(/[ -]/g,"");
		var cardNumberLength = cardNumbersOnly.length;
		var lengthIsValid = false;
		var prefixIsValid = false;
		var prefixRegExp;
		switch (cardType) {
			case "Visa":
				lengthIsValid = (cardNumberLength == 16 || cardNumberLength == 13);
				prefixRegExp = /^4/;
				break;
			case "MasterCard":
				lengthIsValid = (cardNumberLength == 16);
				prefixRegExp = /^5[1-5]/;
				break;
			case "Discover":
				lengthIsValid = (cardNumberLength == 16);
				prefixRegExp = /^6011/;
				break;
			case "AmEx":
				lengthIsValid = (cardNumberLength == 15);
				prefixRegExp = /^3(4|7)/;
				break;
			default:
				return false;
		}
		prefixIsValid = prefixRegExp.test(cardNumbersOnly);
		isValid = prefixIsValid && lengthIsValid;
	}
	if (isValid) {
		var numberProduct;
		var numberProductDigitIndex;
		var checkSumTotal = 0;
		for (digitCounter = cardNumberLength - 1; digitCounter >= 0; digitCounter--) {
			checkSumTotal += parseInt (cardNumbersOnly.charAt(digitCounter));
			digitCounter--;
			numberProduct = String((cardNumbersOnly.charAt(digitCounter) * 2));
			for (var i = 0; i < numberProduct.length; i++) {
				checkSumTotal += parseInt(numberProduct.charAt(i));
			}
		}
		isValid = (checkSumTotal % 10 == 0);
	}
	return isValid;
}

function validateEmail(str,warn) {
	if (window.RegExp) {
		var reg1str = "(@.*@)|(\\.\\.)|(@\\.)|(\\.@)|(^\\.)";
		var reg2str = "^.+\\@(\\[?)[a-zA-Z0-9\\-\\.]+\\.([a-zA-Z]{2,4}|[0-9]{1,3})(\\]?)$";
		var reg1 = new RegExp(reg1str);
		var reg2 = new RegExp(reg2str);
		if (!reg1.test(str) && reg2.test(str)) {
			return true;
		}
	} else {
		if (str.indexOf("@") >= 0 && str.indexOf(".") >= 0) {
			return true;
		}
	}
	if (warn == true) {
		alert('Invalid email address:' + str);
	}
	return false;
}

function email_fix(email) {
	if (email.indexOf('@') >= 0) {
		email = email.replace(/ /g,"").replace(/@+/g,"@");
		var left_bracket = email.indexOf('<');
		if (left_bracket >= 0) {
			var right_bracket = email.indexOf('>',left_bracket);
			if (right_bracket >= 0) {
				email = email.substring(left_bracket+1,right_bracket)
			}
		}
	}
	return email;
}






function updateIFrame( height ) {
	var iframe = document.getElementById( 'CCIFrame' );
	iframe.setAttribute( 'height', height );
}

function updateNav() {
	$.get('profile/ajax/nav.cfm', {}, function(data) {
		$('.sidebar1').html(data);
		resetNav();
	});
}


function validateEmail(e) {
	return true;
}

function bi(obj) {
	return document.getElementById(obj);
}

function toggle_show_hide(elementId) {
	var el = bi(elementId);
	el.style.display = (el.style.display == 'none') ? 'block' : 'none';
}


function longSchoolName() {
	$('.school_name').html($('.school_name').html() + ' School for the Highly Gifted Destined for Great things');
	setSchoolNameSize();
}

function launchCropEditor(id, src, type) {
	featherEditorType = type;
	featherEditor.launch({
		image: id,
		url: $.trim(src),
		displayImageSize: true,
		initTool:'crop',
		cropPresets: [['Profile Timeline','153:207']]
		//forceCropPreset: ['Profile Timeline','153:228']
	});
	return false;
}

function launchEditor(id, src, type) {
	featherEditorType = type;
	if (type == 1) {
		featherEditor.launch({
			image: id,
			url: $.trim(src),
			displayImageSize: true
		});		
	}
	else {
		featherEditor.launch({
			image: id,
			url: $.trim(src),
			displayImageSize: true,
			cropPresets: [['Profile Timeline','153:207']]
			//forceCropPreset: ['Profile Timeline','153:228']
		});		
	}
	return false;
}